#!/bin/bash
#$Id: ComputingElement-test.sh,v 1.1.1.2 2005/02/08 16:09:42 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone	- Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

. $EDG_TESTROOT/sbin/sourcer.sh

$ECHO -e "\n###############################"
$ECHO    "#### MANDATORY FILES CHECK ####"
$ECHO -e "###############################\n"

$ECHO -n "fileexist /etc/globus.conf ..."
fileexist /etc/globus.conf
print_status

$ECHO -n "getting GRIDMAP from /etc/globus.conf and check file"
checkglobusconfparam GRIDMAP
print_status

$ECHO -n "getting X509_GATEKEEPER_CERT from /etc/globus.conf and check file"
checkglobusconfparam X509_GATEKEEPER_CERT
print_status

$ECHO -n "getting X509_GATEKEEPER_KEY from /etc/globus.conf and check file"
checkglobusconfparam X509_GATEKEEPER_KEY
print_status

$ECHO -n "fileexist /etc/edg/info-mds.conf "
fileexist /etc/edg/info-mds.conf 
print_status

$ECHO -n "getting EDG_LOCATION "
if [ -z $EDG_LOCATION ]; then echo_failure; else echo_success; fi

$ECHO -n "fileexist $EDG_LOCATION/info/mds/etc/ldif/ce-static.ldif "
fileexist $EDG_LOCATION/info/mds/etc/ldif/ce-static.ldif 
print_status


$ECHO -e "\n##########################"
$ECHO    "#### RUNNING SERVICES ####"
$ECHO -e "##########################\n"

$ECHO -n "checkservice edg-crl-upgraded"
checkservice edg-crl-upgraded
print_status

$ECHO -n "checkservice edginfo-mds"
checkservice edginfo-mds
print_status

$ECHO -n "checkservice globus-gatekeeper"
checkservice globus-gatekeeper
print_status

$ECHO -n "checkservice globus-gsi_wuftpd"
checkservice globus-gsi_wuftpd
print_status

$ECHO -n "checkservice globus-mds"
checkservice globus-mds
print_status

$ECHO -n "checkservice inet"
checkservice inet 
print_status

$ECHO -n "checkservice locallogger"
checkservice locallogger 
print_status

$ECHO -n "checkservice nfs"
checkservice nfs 
print_status

$ECHO -n "checkservice nfslock"
checkservice nfslock 
print_status

$ECHO -n "checkservice pbs"
checkservice pbs
print_status

$ECHO -n "checkservice ntp"
checkservice ntp 
print_status

$ECHO -e "\n##################################################"
$ECHO    "#### MANDATORY PARAMETERS IN /etc/globus.conf ####"
$ECHO -e "##################################################\n"

$ECHO -n "getting GLOBUS_LOCATION from /etc/globus.conf and check directory"
checkglobusconfparam GLOBUS_LOCATION
print_status

$ECHO -n "getting GLOBUS_GATEKEEPER_SUBJECT from /etc/globus.conf "
globus_gatekeeper_subject=`getglobusconfparam GLOBUS_GATEKEEPER_SUBJECT`
print_status

$ECHO -n "getting GLOBUS_HOST_DN from /etc/globus.conf "
globus_host_dn=`getglobusconfparam GLOBUS_HOST_DN`
print_status

$ECHO -n "getting GLOBUS_ORG_DN from /etc/globus.conf "
globus_org_dn=`getglobusconfparam GLOBUS_ORG_DN`
print_status

$ECHO -n "getting GLOBUS_GATEKEEPER_HOST from /etc/globus.conf "
globus_gatekeeper_host=`getglobusconfparam GLOBUS_GATEKEEPER_HOST`
print_status

$ECHO -n "getting GATEKEEPER_PORT from /etc/globus.conf "
gatekeeper_port=`getglobusconfparam GATEKEEPER_PORT`
print_status

$ECHO -n "getting GATEKEEPER_LOG from /etc/globus.conf and check file"
checkglobusconfparam GATEKEEPER_LOG
print_status

$ECHO -n "getting X509_CERT_DIR from /etc/globus.conf and check directory"
checkglobusconfparam X509_CERT_DIR
print_status

$ECHO -n "getting GLOBUS_JOBMANAGERS from /etc/globus.conf "
globus_jobmanagers=`getglobusconfparam GLOBUS_JOBMANAGERS`
print_status

$ECHO -n "getting GSIWUFTPPORT from /etc/globus.conf "
gsiwuftpport=`getglobusconfparam GSIWUFTPPORT`
print_status

$ECHO -n "getting GSIWUFTPDLOG from /etc/globus.conf and check file"
checkglobusconfparam GSIWUFTPDLOG
print_status

$ECHO -n "getting GLOBUS_FLAVOR_NAME from /etc/globus.conf "
globus_flavor_name=`getglobusconfparam GLOBUS_FLAVOR_NAME`
print_status

$ECHO -n "getting GRID_INFO_EDG from /etc/globus.conf "
grid_info_edg=`getglobusconfparam GRID_INFO_EDG`
print_status

$ECHO -n "getting GRIDMAPDIR from /etc/globus.conf "
gridmapdir=`getglobusconfparam GRIDMAPDIR`
print_status

$ECHO -n "direxist $gridmapdir"
fileexist $gridmapdir
print_status

$ECHO -n "getting GRID_INFO_GRIS_REG_GIIS from /etc/globus.conf "
grid_info_grid_reg_giis=`getglobusconfparam GRID_INFO_GRIS_REG_GIIS`
print_status

$ECHO -n "getting GRID_INFO_GRIS_REG_HOST from /etc/globus.conf "
grid_info_grid_reg_host=`getglobusconfparam GRID_INFO_GRIS_REG_HOST`
print_status

$ECHO -n "getting GRID_INFO_GRIS_REG_HOST from /etc/globus.conf "
grid_info_grid_reg_host=`getglobusconfparam GRID_INFO_GRIS_REG_HOST`
print_status

$ECHO -n "getting GLOBUS_GATEKEEPER from /etc/globus.conf "
globus_gatekeeper=`getglobusconfparam GLOBUS_GATEKEEPER`
print_status

$ECHO -n "fileexist $globus_gatekeeper"
fileexist $globus_gatekeeper
print_status

$ECHO -n "getting GLOBUS_GATEKEEPER_OPTIONS from /etc/globus.conf "
globus_gatekeeper_options=`getglobusconfparam GLOBUS_GATEKEEPER_OPTIONS`
print_status

$ECHO -n "getting GLOBUS_GSIWUFTPD_UMASK from /etc/globus.conf "
globus_gsiwuftpd_umask=`getglobusconfparam GLOBUS_GSIWUFTPD_UMASK`
print_status

$ECHO -n "getting GRID_INFO_GRIS from /etc/globus.conf "
grid_info_gris=`getglobusconfparam GRID_INFO_GRIS`
print_status

$ECHO -n "getting GRID_INFO_USER from /etc/globus.conf "
grid_info_user=`getglobusconfparam GRID_INFO_USER`
print_status

$ECHO -n "checking $grid_info_user user"
checkuser $grid_info_user
print_status

$ECHO -n "getting GLOBUS_GRAM_JOB_MANAGER_QSUB from /etc/globus.conf and check file"
checkglobusconfparam GLOBUS_GRAM_JOB_MANAGER_QSUB
print_status

$ECHO -n "getting GLOBUS_GRAM_JOB_MANAGER_QDEL from /etc/globus.conf and check file"
checkglobusconfparam GLOBUS_GRAM_JOB_MANAGER_QDEL
print_status

$ECHO -n "getting GLOBUS_GRAM_JOB_MANAGER_QSTAT from /etc/globus.conf and check file"
checkglobusconfparam GLOBUS_GRAM_JOB_MANAGER_QSTAT
print_status

$ECHO -n "getting GLOBUS_GRAM_JOB_MANAGER_MPIRUN from /etc/globus.conf and check file"
checkglobusconfparam GLOBUS_GRAM_JOB_MANAGER_MPIRUN
print_status

$ECHO -e "\n################################"
$ECHO    "#### USER ENVIRONMENT CHECK ####"
$ECHO -e "##################################\n"

$ECHO -n "fileexist /etc/profile.d/globus.sh"
fileexist /etc/profile.d/globus.sh
print_status

$USERADD tstacct

userpath=`su - tstacct -c "$ECHO \$PATH"`
userldlib=`su - tstacct -c "$ECHO \$LD_LIBRARY_PATH"`

$ECHO -n "checking /opt/globus/bin in \$PATH"
checkpathvar $userpath /opt/globus/bin
print_status

$ECHO -n "checking /opt/globus/sbin in \$PATH"
checkpathvar $userpath /opt/globus/sbin
print_status

$ECHO -n "checking /opt/edg/bin in \$PATH"
checkpathvar $userpath /opt/edg/bin
print_status

$ECHO -n "checking /opt/globus/lib in \$LD_LIBRARY_PATH"
checkpathvar $userldlib /opt/globus/lib
print_status

$ECHO -n "checking /opt/edg/lib in \$LD_LIBRARY_PATH"
checkpathvar $userldlib /opt/edg/lib
print_status

$USERDEL -r tstacct

$ECHO -e "\n########################################################"
$ECHO    "#### MANDATORY PARAMETERS IN /etc/edg/info-mds.conf ####"
$ECHO -e "########################################################\n"

$ECHO -n "getting WP3_DEPLOY from /etc/edg/info-mds.conf"
wp3_deploy=`getfileparam WP3_DEPLOY /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting FTREE_INFO_PORT from /etc/edg/info-mds.conf"
ftree_info_port=`getfileparam FTREE_INFO_PORT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting FTREE_DEBUG_LEVEL from /etc/edg/info-mds.conf"
ftree_debug_level=`getfileparam FTREE_DEBUG_LEVEL /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_DN from /etc/edg/info-mds.conf"
site_dn=`getfileparam SITE_DN /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting GRID_INFO_USER from /etc/edg/info-mds.conf"
grid_info_user=`getfileparam GRID_INFO_USER /etc/edg/info-mds.conf`
print_status

$ECHO -n "checking for user $grid_info_user"
checkuser $grid_info_user
print_status

$ECHO -n "getting SITE_INFO from /etc/edg/info-mds.conf"
site_info=`getfileparam SITE_INFO /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_NAME from /etc/edg/info-mds.conf"
site_name=`getfileparam SITE_NAME /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_CPU_RESOURCE_DESCRIPTION from /etc/edg/info-mds.conf"
site_cpu_resource_description=`getfileparam SITE_CPU_RESOURCE_DESCRIPTION /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_DISK_RESOURCE_DESCRIPTION from /etc/edg/info-mds.conf"
site_disk_resource_description=`getfileparam SITE_DISK_RESOURCE_DESCRIPTION /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_INSTALLATION_DATE from /etc/edg/info-mds.conf"
site_installation_date=`getfileparam SITE_INSTALLATION_DATE /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_SYSADMIN_CONTACT from /etc/edg/info-mds.conf"
site_sysadmin_contact=`getfileparam SITE_SYSADMIN_CONTACT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_USER_SUPPORT_CONTACT from /etc/edg/info-mds.conf"
site_user_support_contact=`getfileparam SITE_USER_SUPPORT_CONTACT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_SECURITY_CONTACT from /etc/edg/info-mds.conf"
site_security_contact=`getfileparam SITE_SECURITY_CONTACT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_DATAGRID_VERSION from /etc/edg/info-mds.conf"
site_datagrid_version=`getfileparam SITE_DATAGRID_VERSION /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_SE_HOSTS from /etc/edg/info-mds.conf"
site_se_hosts=`getfileparam SITE_SE_HOSTS /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_CE_HOSTS from /etc/edg/info-mds.conf"
site_ce_hosts=`getfileparam SITE_CE_HOSTS /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting NETMON_PRESENT from /etc/edg/info-mds.conf"
netmon_present=`getfileparam NETMON_PRESENT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting NETMON_PINGER_HOST from /etc/edg/info-mds.conf"
netmon_pinger_host=`getfileparam NETMON_PINGER_HOST /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting CE_PRESENT from /etc/edg/info-mds.conf"
ce_present=`getfileparam CE_PRESENT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting CE_PRESENT from /etc/edg/info-mds.conf"
ce_present=`getfileparam CE_PRESENT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting CE_HOST from /etc/edg/info-mds.conf"
ce_host=`getfileparam CE_HOST /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting CE_BATCHSYSTEM from /etc/edg/info-mds.conf"
ce_batchsystem=`getfileparam CE_BATCHSYSTEM /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting CE_CLUSTER_BATCH_SYSTEM_BIN_PATH from /etc/edg/info-mds.conf"
ce_cluster_batchsystem_bin_path=`getfileparam CE_CLUSTER_BATCH_SYSTEM_BIN_PATH /etc/edg/info-mds.conf`
print_status

$ECHO -n "fileexist $ce_cluster_batchsystem_bin_path "
fileexist $ce_cluster_batchsystem_bin_path
print_status

$ECHO -n "getting CE_STATIC_LDIF from /etc/edg/info-mds.conf"
ce_static_ldif=`getfileparam CE_STATIC_LDIF /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting CE_QUEUE from /etc/edg/info-mds.conf"
ce_queue=`getfileparam CE_QUEUE /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting CE_CLOSE_SE_ID from /etc/edg/info-mds.conf"
ce_close_se_id=`getfileparam CE_CLOSE_SE_ID /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting CE_CLOSE_SE_MOUNT_POINT from /etc/edg/info-mds.conf"
ce_close_se_mount_point=`getfileparam CE_CLOSE_SE_MOUNT_POINT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_NETMON_HOST from /etc/edg/info-mds.conf"
site_netmon_host=`getfileparam SITE_NETMON_HOST /etc/edg/info-mds.conf`
print_status

$ECHO -e "\n##################################"
$ECHO    "#### NFSmount check procedure ####"
$ECHO -e "##################################\n"

$ECHO -n "check nfsmount for CE"
check_nfs_mount=`checknfsmount CE`
print_status

$ECHO -e "\n#############################"
$ECHO    "#### RPM check procedure ####"
$ECHO -e "#############################\n"

$ECHO "verify RPM list installation"
rpmchecker $EDG_TESTROOT/sbin/CE-v1_2_2.rpmlist
print_status

$ECHO -e "\n###############################"
$ECHO    "####   MDS / GRIS CHECK    ####"
$ECHO -e "###############################\n"

$ECHO -n "ceinfoprovcheck "
ceinfoprovcheck
print_status

$ECHO -e "\n###############################"
$ECHO    "####   MDS / GRIS QUERY    ####"
$ECHO -e "###############################\n"

$ECHO -n "grisqueryce "
grisqueryce
print_status

$ECHO -e "\n######################"
$ECHO    "####   PBS CHECK   ####"
$ECHO -e "#######################\n"

$ECHO "verify /usr/spool/PBS/pbs_environment "
checkPBSenv
print_status

$ECHO "verify /usr/spool/PBS/server_priv/nodes with layout.sh info "
checkPBSnodes
print_status

$ECHO "verify /usr/spool/PBS/server_name with layout.sh info "
checkPBSservername
print_status

$ECHO "verify PBS queues with /etc/edg/info-mds.conf info "
checkPBSqueue
print_status

#

