#!/bin/bash
#$Id: checkEnvVariable.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################
# Modified : F.Chollet Simplify  

##################################################################
# FUNCTION: checkenvvariable<varname>
#
# ARGUMENTS: <varname> {string} (mandatory)
#
# DESCRIPTION: check if an environmental variable is set
#
# RETURN VALUE: 0 - if <varname> is defined
#		1 - if <varname> is not defined	
#	        4 - no mandatory parameter is passed
##################################################################

checkenvvariable()
{
   if [ -z $1 ]
   then
	[ $DEBUG ] && $ECHO "checkenvvariable(): no mandatory parameter is passed"
	return 4
   fi

   local status

#   status=`set | $GREP $1 | grep = | grep -v checkenvvariable | grep -v ';'>> /dev/null ; echo $?`
    status=`set | $GREP $1 >/dev/null; echo $?`

#   defin=`env | $GREP $1` 

   if [ $status = 0 ]
        then
#                [ $DEBUG ] && $ECHO "checkenvvariable(): variable $1 is defined as " $defin
               [ $DEBUG ] && $ECHO "checkenvvariable(): variable $1 is defined." 
                return 0 
        else
                [ $DEBUG ] && $ECHO "checkenvvariable(): variable $1 is NOT defined"
                return 1
        fi
}
