#!/bin/bash
#$Id: checkGlobusConfParam.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: checkglobusconfparam <variable>
#
# ARGUMENTS: <variable> {string} (mandatory)
#
# DESCRIPTION: check if <variable> is defined in /etc/globus.conf
#	       and check if <variable> filename exists
#
# RETURN VALUE: 0 - if <variable> is defined AND <variable> filename exists
#		1 - if <variable> is not defined OR <variable> filename does not exist
#	        4 - no mandatory parameter is passed
##################################################################

checkglobusconfparam()
{
   if [ -z $1 ]
   then
        [ $DEBUG ] && $ECHO "checkglobusconfparam(): no mandatory parameter is passed"
	return 4
   fi

   local value
   local varname=$1

   value=`getglobusconfparam $varname` 

   if [ -z "$value" ]
   then
	[ $DEBUG ] && $ECHO "checkglobusconfparam(): variable $varname is NOT defined!"
   	return 1
   fi

   fileexist $value
   retval=$?
   
   return $retval
}
