#!/bin/bash
#$Id: checkNfsMount.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################
# modified : F.Chollet 13/03/03 perform the test on CE_CLOSE_SE_ID 
#                               could be a list 
##################################################################
# FUNCTION: checknfsmount <grid-element> 
#
# ARGUMENTS: <grid-element> {CE,WN} SEId (mandatory)
#
# DESCRIPTION: check if all nfsmount are correctly mounted
#
# RETURN VALUE: 0 - if all is OK
#		1 - if one (or more) nfsmount are not present
#               4 - if no mandatory parameter is passed
##################################################################
# 

checknfsmount()
{
   if [ -z $1 ]
   then
        [ $DEBUG ] && $ECHO "checknfsmount(): no mandatory parameter is passed"
	return 4
   fi   
   local node=$1
   local SEId

   set -- $CE_CLOSE_SE_ID
  
   local retval=0

   for SEId in $@ ; do
    local SEexportfs=`$SHOWMOUNT -e $SEId | $GREP "/" | $CUT -f1 -d' '`

    local mountstringCE="$CEhostname:/home" # VO users home directories
    local mountstringSE="$SEId:$SEexportfs" # SE storage areas
    local mountstringLCFG="$LCFGhostname:/opt/local/linux/6.2" # LCFG area

   # Worker Node checks

    if [ $node = "WN" ]
    then
#	$GREP $mountstringCE /etc/mtab 
#        if [ $? -eq 0 ] ; then  
#	   [ $DEBUG ] && $ECHO "checknfsmount(): WN nfsmount: $mountstringCE (ok)"
#        else 
#	   [ $DEBUG ] && $ECHO "checknfsmount(): WN nfsmount: $mountstringCE (failed)"; retval=1
#	fi    
	$GREP $mountstringSE /etc/mtab 
	if [ $? -eq 0 ] ; then
	   [ $DEBUG ] && $ECHO "checknfsmount(): WN nfsmount: $mountstringSE (ok)"
	else
	   [ $DEBUG ] && $ECHO "checknfsmount(): WN nfsmount: $mountstringSE (failed)"; retval=1
	fi
#    	$GREP $mountstringLCFG /etc/mtab
#	if [ $? -eq 0 ] ; then
#	   [ $DEBUG ] && $ECHO "checknfsmount(): WN nfsmount: $mountstringLCFG (ok)"
#	else    
#	   [ $DEBUG ] && $ECHO "checknfsmount(): WN nfsmount: $mountstringLCFG (failed)" ; retval=1
#	fi
    fi 	


   # Computing Element checks

   if [ $node = "CE" ]
   then 
	$GREP $mountstringSE /etc/mtab 
	if [ $? -eq 0 ] ; then
	   [ $DEBUG ] && $ECHO "checknfsmount(): WN nfsmount: $mountstringSE (ok)"
	else
	   [ $DEBUG ] && $ECHO "checknfsmount(): WN nfsmount: $mountstringSE (failed)"; retval=1
	fi
#    	$GREP $mountstringLCFG /etc/mtab
#	if [ $? -eq 0 ] ; then
#	   [ $DEBUG ] && $ECHO "checknfsmount(): WN nfsmount: $mountstringLCFG (ok)"
#	else    
#	   [ $DEBUG ] && $ECHO "checknfsmount(): WN nfsmount: $mountstringLCFG (failed)" ; retval=1
#	fi
   fi
  done  
  return $retval  
}
