#!/bin/bash
#$Id: checkPBSservername.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: checkPBSservername
#
# ARGUMENTS: none
#
# RETURN VALUE: 0 - if all is configured properly
#               1 - if there are some errors
##################################################################

checkPBSservername()
{
	local shortCEhostname=`$ECHO $CEhostname | $CUT -d'.' -f1`

	local match=`$GREP -w "$CEhostname" /usr/spool/PBS/server_name > /dev/null; $ECHO $?`
	local shortmatch=`$GREP -w "$shortCEhostname" /usr/spool/PBS/server_name > /dev/null; $ECHO $?`

	if [ $match -ne 0 ] && [ $shortmatch -ne 0 ]; then
		return 1
	fi

	local numlines=`$CAT /usr/spool/PBS/server_name | $WC -l | $TR -d ' '`

	if [ $numlines -ne 1 ]; then
		return 1
	fi

   return 0

}
