#!/bin/bash
#$Id: checkPathVar.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: checkpathvar <path_variable> <path_to_check>
#
# ARGUMENTS: <path_variable> {string} (mandatory)
#	     <path_to_check> {string} (mandatory)
#
# DESCRIPTION: check if <path_to_check> is defined in <path_variable>
#	       Note: the format of <path_variable> *must be* val1:val2:...:valn 
#
# RETURN VALUE: 0 - if <path_to_check> is defined
#               1 - if <path_to_check> is not defined 
#               4 - no mandatory parameter is passed
##################################################################

checkpathvar()
{
   if [ -z $1 ]
   then
        [ $DEBUG ] && $ECHO "checkpathvar(): no mandatory parameter is passed"
	return 4
   fi

   if [ -z $2 ]
   then
        [ $DEBUG ] && $ECHO "checkpathvar(): no mandatory parameter is passed"
        return 4
   fi
 
   pathlist=`$ECHO $1 | $SED "s/:/ /g"`   
   
   retval=1 
   for i in $pathlist
   do
	if [ $i = $2 ]; then
 	  retval=0
	fi 
   done

   return $retval

}
