#!/bin/bash
#$Id: checkService.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: checkservice <service>
#
# ARGUMENTS: <service> {string} (mandatory)
#
# DESCRIPTION: check if <service> is running
#
# RETURN VALUE: 0 - if <service> is running 
#               1 - if <service> is not running 
#               4 - no mandatory parameter is passed
##################################################################

checkservice()
{
   if [ -z $1 ]
   then
        [ $DEBUG ] && $ECHO "checkservice(): no mandatory parameter is passed"
	return 4
   fi

   local status

   # first check in /etc/rc.d/init.d

  
   if [ -e /etc/rc.d/init.d/$1 ] &&  [ $1 != "mysql" ]
   then

        status=`/etc/rc.d/init.d/$1 status | $GREP running > /dev/null ; echo $?`

	if [ $status = 0 ]
	then
   		[ $DEBUG ] && $ECHO "checkservice(): service $1 is running"
		return 0
	else
		[ $DEBUG ] && $ECHO "checkservice(): service $1 is NOT running"
		return 1
	fi

   else
   
   # second check with 'netstat -a'


   	status=`$NETSTAT -a | $GREP $1 | $WC -l` 

   	if [ $status = 0 ]
   	then
		[ $DEBUG ] && $ECHO "checkservice(): service $1 is NOT running"
		return 1
   	else
		[ $DEBUG ] && $ECHO "checkservice(): service $1 is running"
		return 0
	fi
   fi
}
