#!/bin/bash
#$Id: checkUser.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: checkuser <user> 
#
# ARGUMENTS: <user> {string} (mandatory)
#
# DESCRIPTION: check if <user> is defined in /etc/passwd
#
# RETURN VALUE: 0 - if <user> is defined
#		1 - if <user> is not defined 
#	        4 - no mandatory parameter is passed
##################################################################

checkuser()
{
   if [ -z $1 ]
   then
        [ $DEBUG ] && $ECHO "checkuser(): no mandatory parameter is passed"
	return 4
   fi    

   local user

   user=`$GREP $1 /etc/passwd | $CUT -f1 -d":" | head -1`

   if [ $user ]
   then
	[ $DEBUG ] && $ECHO "checkuser(): user $1 is defined"
   	return 0
   else
	[ $DEBUG ] && $ECHO "checkuser(): user $1 is NOT defined"
   	return 1
   fi
}
