#!/bin/bash
#$Id: echoFunc.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################
# 18/02/03 F.Chollet
# escape sequences not compatible with non interactive execution and 
# html browsing of log files
# in this case MOVE_TO_COL is replaced by a % used to delimit the column
# cat log.txt | column -s % -t used later on to display the results
# nice colors removed

export RES_COL=70
export MOVE_TO_COL="echo -en \\033[${RES_COL}G"
export SETCOLOR_SUCCESS="echo -en \\033[1;32m"
export SETCOLOR_FAILURE="echo -en \\033[1;31m"
export SETCOLOR_WARNING="echo -en \\033[1;33m"
export SETCOLOR_NORMAL="echo -en \\033[0;39m"

  
echo_success() {
   $MOVE_TO_COL
   echo -n "[  "
   $SETCOLOR_SUCCESS
   echo -n "OK"
   $SETCOLOR_NORMAL
   echo -n "   ]"
   echo -e "\r" 
   return 0
   
}

echo_failure() {
   $MOVE_TO_COL
   echo -n "[ "
   $SETCOLOR_FAILURE
   echo -n "FAILED"
   $SETCOLOR_NORMAL
   echo -n "]"
   echo -e "\r"
   return 1
}

echo_passed() {
   $MOVE_TO_COL
   echo -n "[ "
   $SETCOLOR_NORMAL
   echo -n "PASSED"
   $SETCOLOR_NORMAL
   echo -n "]"
   echo -e "\r"
   return 1
}

echo_warning() {
   $MOVE_TO_COL
   echo -n "["
   $SETCOLOR_WARNING
   echo -n "WARNING"
   $SETCOLOR_NORMAL
   echo -n "]"
   echo -e "\r"
   return 1
}

echo_xfail() {
   $MOVE_TO_COL
   echo -n "[ "
   $SETCOLOR_NORMAL
   echo -n "XFAIL"
   $SETCOLOR_NORMAL
   echo -n " ]"
   echo -e "\r"
   return 1
}

echo_unresolved() {
   $MOVE_TO_COL
   echo -n "["
   $SETCOLOR_WARNING
   echo -n "UNRSLVD"
   $SETCOLOR_NORMAL
   echo -n "]"
   echo -e "\r"
   return 1
}

echo_untested() {
   $MOVE_TO_COL
   echo -n "["
   $SETCOLOR_WARNING
   echo -n "UNTESTD"
   $SETCOLOR_NORMAL
   echo -n "]"
   echo -e "\r"
   return 1
}
print_status() {

 if  [ "$?"  = 0 ]; then
         echo_success
         let "counter_success += 1" 
 else
  

 ##if  [ "$?" != 0 ]; then
          echo_failure
          let "counter_failure += 1"
 fi


}
