#!/bin/bash
#$Id: extractGlobusConfParam.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
# Modified : F.Chollet TSTG 15/01/03 - chollet@lapp.in2p3.fr
#            Use GLOBUS_CONFIG variable if defined  
######################################################################


##################################################################
# FUNCTION: extractglobusconfparam <variable>
#
# ARGUMENTS: <variable> {string} (mandatory)
#
# DESCRIPTION: check if <variable> is defined in /etc/globus.conf
#	       and returns value
#
# RETURN VALUE: 0 - if <variable> is defined (value in output)
#		1 - if <variable> is not defined 
#	        4 - no mandatory parameter is passed
##################################################################

extractglobusconfparam()
{
   if [ -z $1 ]
   then
        [ $DEBUG ] && $ECHO "getglobusconfparam(): no mandatory parameter is passed"
	return 4
   fi

   if [ -z "$GLOBUS_CONFIG" ] 
   then    
	source $EDG_TEST_GLCF
   else
	source $GLOBUS_CONFIG
   fi
  
   local varname=$1
   eval local varvalue=$`$ECHO $1`

   if [ "$varvalue" ]
   then
	##[ $DEBUG ] && $ECHO "getglobusconfparam(): variable is defined ($varname = $varvalue)"
	$ECHO "$varvalue"
	return 0
   else
	##[ $DEBUG ] && $ECHO "getglobusconfparam(): variable $varname is NOT defined!"
   	$ECHO ""	
	return 1
   fi
}
