

#!/bin/bash
#$Id: fileExist.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: fileexist <filename>
#
# ARGUMENTS: <filename> {string} (mandatory)
#
# DESCRIPTION: check if a file exists
#
# RETURN VALUE: 0 - if <filename> exists
#		1 - if <filename> does not exist	
#	        4 - no mandatory parameter is passed
##################################################################

fileexist()
{
   if [ -z $1 ]
   then
	[ $DEBUG ] && $ECHO "fileexist(): no mandatory parameter is passed"
	return 4
   fi

   if [ -e $1 ] 
   then
	[ $DEBUG ] && $ECHO "fileexist(): file $1 is there."
	return 0
   else
        $ECHO "ERROR: fileexist(): file $1 does not exist."
	return 1
   fi
}

