#!/bin/bash
#$Id: getRpmList.sh,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $
######################################################################
#
# Authors: Antonio Forte - Antonio.Forte@to.infn.it
#	   Gennaro Tortone - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
# Modified : F.Chollet chollet@lapp.in2p3.fr name of temporary file
######################################################################
#
# FUNCTION: getrpmlist <grid_element> <edg_release>
#
# ARGUMENTS: <grid_element> {string} (mandatory)
#	     <edg_release> {string} (mandatory)
#
# DESCRIPTION: get <edg_release> rpmlist from EDG repository
#
# RETURN VALUE: 0 - ok
#               1 - errors
#               4 - no mandatory parameter is passe
##################################################################

getrpmlist()
{
   if [ -z $1 ]; then
	[ $DEBUG ] && $ECHO "getrpmlist(): no mandatory parameter is passed"
	return 4
   fi
   
   if [ -z $2 ]; then
        [ $DEBUG ] && $ECHO "getrpmlist(): no mandatory parameter is passed"
        return 4
   fi

   gridelement=$1
   release=$2
   
   $WGET -r -nd http://datagrid.in2p3.fr/autobuild/rh6.2/rpmlist/$gridelement-All-v$release.html -O $EDG_TEST_TMP/$$_$gridelement-$release.html 2>&1
   
   RPM=`$GREP "a href" $EDG_TEST_TMP/$$_$gridelement-$release.html | $SED -e 's/^.*href="//' -e 's/.i[356]86.rpm.*$//' -e 's/.noarch.rpm.*$//'`

   for RPM_FILE in $RPM
   do
        $BASENAME $RPM_FILE >> $EDG_TEST_TMP/$$_$gridelement-$release.rpmlist
   done
   $RM -f $EDG_TEST_TMP/$$_$gridelement-$release.html
}
