###################################################################################
#
# Authors :     Francesco Giacomini   -   Francesco.Giacomini@cnaf.infn.it
#               Mario Reale           -   Mario.Reale@cnaf.infn.it
#
# Hacked by:    Andrea Formica        -   Andrea.Formica@cea.fr
#
###################################################################################
# Description : it downloads RPM lists from datagrid.in2p3.fr for EDG 1.2 Beta9
#
# Usage :   get_RPM_list.sh <GRID-ELEMENT> <GRIDPKG_VERSION>
#    
#        where GRID-ELEMENT can be one of the following:   WN, SE, UI, RB, CE   
#              GRIDPKG_VERSION can be All-beta9, external-beta9, edg-beta9
#                                     ca-beta9, appcommon-beta9, globus-beta9
#                              or simply external, edg, ... if no beta version
#                              is wanted.
###################################################################################
# Do not download openssh in the lists
#
lynx -dump -width 300 --nolist \
http://datagrid.in2p3.fr/autobuild/rh6.2/rpmlist/${1}-${2}${EDG_VERSION_NAME}.html | \
sed -e '/\.rpm$/ ! d' -e 's/^ *//' -e '/^openssh-*/ d' 

#http://datagrid.in2p3.fr/autobuild/rh6.2/rpmlist/${1}-${2}_edg_1_2.html | \
#sed -e '/\.rpm$/ ! d' -e 's/\.\(i386\|noarch\)\.rpm$//' -e 's/^ *//' 
