#! /usr/bin/env bash
###############################################################
###############################################################
##
##                    INSERT TITLE START
##    
###############################################################
###############################################################
##
## Author: Metery Rene - CS-SI (FRANCE)
##         rene.metery@c-s.fr
## Date: January 09th 2003
## Last modification : January 09th 2003
## Version: 1.0
## Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
##     http://www.edg.org/license.html or see LICENSE file
##
###############################################################
###############################################################
##
## FUNCTION: inserttitlestart <returncode> <test>
##
## ARGUMENTS: <returncode> {string} (mandatory) 
##            <text>       {string} (mandatory)
##
## DESCRIPTION: begin inserting a menu in an HTML report
##              with a the title passed in argument
##              
## EXIT CODE: 0 - if the script finishes
##            
###############################################################
###############################################################

inserttitlestart()
{
 source $EDG_TEST_FUNCTIONS/common.sh
 source $EDG_TEST_FUNCTIONS/HTML_func.sh
 source $EDG_TEST_CONF_FILE

 if [ -z $1 ]
 then
       [ $DEBUG ] && $ECHO "insertTitleStart(): no mandatory parameter (1) is passed"
       return 4
 fi
		      
 if [ -z $2 ]
 then
       [ $DEBUG ] && $ECHO "insertTitleStart.sh(): no mandatory parameter (2) is passed"
       return 4
 fi 

 if test $1 = 4
 then
       return 0
 fi


 HTML_validate $1

 HTML_dump col_end.html
 HTML_dump row_end.html

 HTML_dump row_start.html
 HTML_dump first_col_start.html
 HTML_echo "$2"
 HTML_dump first_col_end.html
 HTML_dump col_start.html

 return 0
}