#!/bin/bash
######################################################################
#
# Authors: Miquel Barcelo  - barcelo@ifae.es
#          Gonzalo Merino  - merino@ifae.es
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: loadVars <file>
#
# ARGUMENTS: <file>    {string} (mandatory)
#
# DESCRIPTION: loads the content of environment variables from a file 
#
#
# RETURN VALUE: 0 - if <command> successful
#               1 - if <command> is not successful
#	        4 - no mandatory parameter is passed
##################################################################

loadVars()
{
    if [ -z "$1" ] 
    then
	message 1 "loadVars(): no mandatory parameter is passed"
	return 4
    fi    

    local STATEFILE=$1

    if [ -e "$STATEFILE" ]
    then
	source $STATEFILE
    fi
    return 0

}
