#!/bin/bash
######################################################################
#
# Authors: Miquel Barcelo  - barcelo@ifae.es
#	   Gonzalo Merino  - merino@ifae.es
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: message <level> <message>
#
# ARGUMENTS: <level>      {integer} (mandatory)
#            <message>    {string}  (mandatory)
#
# DESCRIPTION: echoes an message to stdout if its level is lower or equal
#              than globally defined VERBOSE_LEVEL. For debugging 
#                       
# RETURN VALUE: 0 - all
#	        4 - no mandatory parameter is passed
#
# VERBOSE_LEVELS: 0 - no output
#
#
##################################################################

VERBOSE_LEVEL=1 

message()
{
   if [ -z "$1" ] || [ -z "$2" ]
   then
        $ECHO "message(): no mandatory parameter is passed"
	return 4
   fi

   # How to check that <level> is really a number???
   if [ $VERBOSE_LEVEL -ge $1 ]
   then
	$ECHO "$2"
   fi
   return 0
}

