#!/bin/bash
######################################################################
#
# Authors: Miquel Barcelo  - barcelo@ifae.es
#          Gonzalo Merino  - merino@ifae.es
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: saveVars <file> <var list>
#
# ARGUMENTS: <file>     {string} (mandatory)
#            <var list> {string} (mandatory)
#
# DESCRIPTION: saves the content of environment variables to a file 
#
#
# RETURN VALUE: 0 - if <command> successful
#               1 - if <command> is not successful
#	        4 - no mandatory parameter is passed
##################################################################

saveVars()
{
   if [ -z "$1" ] || [ -z "$2" ] 
   then
        message 1 "saveVars(): no mandatory parameter is passed"
	return 4
   fi    

   local STATEFILE=$1

    if [ -e "$STATEFILE" ] ; then
	rm -f $STATEFILE
    fi

    for i in $2 ; do
	eval j=$`echo $i`
	echo "$i=$j" >> $STATEFILE
    done
    return 0
}
