#! /usr/bin/env bash
###############################################################
###############################################################
##
##              SOURCE TEST_SITE.CONF FILE
##    
###############################################################
###############################################################
##
## Author: Metery Rene - CS-SI (FRANCE)
##         rene.metery@c-s.fr
## Date: December 19th 2002
## Last modification : December 19th 2002
## Version: 1.0
## Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
##     http://www.edg.org/license.html or see LICENSE file
##
###############################################################
###############################################################
##
## FUNCTION: sourcetestsiteconffile
## ARGUMENTS: none
##
## DESCRIPTION: source the user test_site.conf file if
##              it exists or source the test_site.conf
##              file at its default location.
##              
## EXIT CODE: 0 - file sourced
##            
###############################################################
###############################################################

sourcetestsiteconffile()
{
 DIRECTORY=$HOME/.edg-tsft
 FILENAME=test_site.conf
 
 ### Directory $DIRECTORY exists ? ###
 if test -d $DIRECTORY
 then
       ### Yes
       ### File $DIRECTORY/$FILENAME exists ?
       if test -e $DIRECTORY/$FILENAME
       then
             ### Yes
             . $DIRECTORY/$FILENAME
	     $ECHO "Site Configuration file: $DIRECTORY/$FILENAME file sourced"
             return 0
       else
             ### No
             if test -e $EDG_TEST_SITE_CONF
	     then 
		 . $EDG_TEST_SITE_CONF
		 $ECHO "Site Configuration file: $EDG_TEST_SITE_CONF"
		 return 0
	     fi  
       fi
 else
       ### No
       if test -e $EDG_TEST_SITE_CONF
       then 
	   . $EDG_TEST_SITE_CONF
	   $ECHO "Site Configuration file: $EDG_TEST_SITE_CONF"
	   return 0
       fi
 fi
}
