#!/bin/bash
######################################################################
#
# Authors: Mario Reale   - Mario.Reale@cnaf.infn.it
#
# Modified by Rene Metery, F.Chollet 
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html

# Modified F.Chollet 20/01/03 functions added using sudo to get file 
#                             parameters in protected files
#                    24/02/03 checkCron.sh, getParamRbConf.sh added  
######################################################################

########################
#                     #
# Sourcing the files #
#                   #
####################
# Common variables definition
. $EDG_TESTROOT/sbin/common.sh
# Misc functions
. $EDG_TESTROOT/sbin/layout.sh
. $EDG_TESTROOT/sbin/loadVars.sh
. $EDG_TESTROOT/sbin/saveVars.sh
. $EDG_TESTROOT/sbin/message.sh
. $EDG_TESTROOT/sbin/randomfilecreate-func.sh
. $EDG_TESTROOT/sbin/echoFunc.sh
. $EDG_TESTROOT/sbin/fileExist.sh
. $EDG_TESTROOT/sbin/findOpenssl.sh
. $EDG_TESTROOT/sbin/testRetCodes.sh
. $EDG_TESTROOT/sbin/mailfunc.sh
. $EDG_TESTROOT/sbin/replace.sh
. $EDG_TESTROOT/sbin/commonenv.sh

# List functions
. $EDG_TESTROOT/sbin/add-list.sh
. $EDG_TESTROOT/sbin/clean-list.sh
. $EDG_TESTROOT/sbin/compare-list.sh
. $EDG_TESTROOT/sbin/create-list.sh
. $EDG_TESTROOT/sbin/dolist-install.sh
. $EDG_TESTROOT/sbin/dolist-restore.sh
. $EDG_TESTROOT/sbin/get-list.sh
. $EDG_TESTROOT/sbin/getpkg-list.sh
. $EDG_TESTROOT/sbin/restore-list.sh
. $EDG_TESTROOT/sbin/write-list.sh

# GRIS and info functions
. $EDG_TESTROOT/sbin/CEInfoProviderCheck.sh
. $EDG_TESTROOT/sbin/SEInfoProviderCheck.sh
. $EDG_TESTROOT/sbin/grisQueryCE.sh
. $EDG_TESTROOT/sbin/grisQuerySE.sh

# Check functions
. $EDG_TESTROOT/sbin/checkUser.sh
. $EDG_TESTROOT/sbin/checkUserEnv.sh
. $EDG_TESTROOT/sbin/checkOpenPort.sh
. $EDG_TESTROOT/sbin/checkGlobusConfParam.sh
. $EDG_TESTROOT/sbin/checkEnvVariable.sh
. $EDG_TESTROOT/sbin/checkService.sh
. $EDG_TESTROOT/sbin/checkServicePs.sh
. $EDG_TESTROOT/sbin/checkMultipleServices.sh
. $EDG_TESTROOT/sbin/checkNfsMount.sh
. $EDG_TESTROOT/sbin/checkBrokerInfo.sh
. $EDG_TESTROOT/sbin/checkPathVar.sh
. $EDG_TESTROOT/sbin/checkProxy.sh
. $EDG_TESTROOT/sbin/checkFiletoFile-func.sh
. $EDG_TESTROOT/sbin/checkRoot.sh
. $EDG_TESTROOT/sbin/checkMD5FiletoFile-func.sh
. $EDG_TESTROOT/sbin/checkCron.sh

# Check PBS functions
. $EDG_TESTROOT/sbin/checkPBSenv.sh
. $EDG_TESTROOT/sbin/checkPBSnodes.sh
. $EDG_TESTROOT/sbin/checkPBSqueue.sh
. $EDG_TESTROOT/sbin/checkPBSservername.sh

# Extract functions
. $EDG_TESTROOT/sbin/extractGlobusConfParam.sh

# Get functions
. $EDG_TESTROOT/sbin/getFileParam.sh
. $EDG_TESTROOT/sbin/getFileParamHead.sh
. $EDG_TESTROOT/sbin/getFileParamTail.sh
. $EDG_TESTROOT/sbin/getPFileParamHead.sh # P = Protected file#
. $EDG_TESTROOT/sbin/getPFileParamTail.sh # P = Protected file#
. $EDG_TESTROOT/sbin/getLogEnd_GDMP.sh
. $EDG_TESTROOT/sbin/getLogID_GDMP.sh
. $EDG_TESTROOT/sbin/getGlobusConfParam.sh
. $EDG_TESTROOT/sbin/getPortNumberEtcServices.sh
. $EDG_TESTROOT/sbin/getPortNumberNetstat.sh
. $EDG_TESTROOT/sbin/getRpmList.sh
. $EDG_TESTROOT/sbin/getPortNumberRbConf.sh
. $EDG_TESTROOT/sbin/getParamRbConf.sh

# Rpms functions
. $EDG_TESTROOT/sbin/classify_rpms.sh
. $EDG_TESTROOT/sbin/install_rpm.sh
. $EDG_TESTROOT/sbin/testrpm.sh
. $EDG_TESTROOT/sbin/rpmCheckerNotInstalledList.sh
. $EDG_TESTROOT/sbin/rpmChecker.sh

# HTML functions
. $EDG_TESTROOT/sbin/HTML_func.sh

# TEST functions
. $EDG_TESTROOT/sbin/TEST_func.sh
. $EDG_TESTROOT/sbin/status-func.sh

# Run command functions
. $EDG_TESTROOT/sbin/runCommand_GDMP.sh
. $EDG_TESTROOT/sbin/runCommand.sh

# Output functions
. $EDG_TESTROOT/sbin/viewReport.sh
. $EDG_TESTROOT/sbin/writeOutput.sh

# Insert title in HTML report functions
. $EDG_TESTROOT/sbin/insertTitleStart.sh
. $EDG_TESTROOT/sbin/insertTitleEnd.sh

# Source functions
. $EDG_TESTROOT/sbin/sourceEdgTestConfFile.sh
. $EDG_TESTROOT/sbin/sourceTestSiteConfFile.sh
. $EDG_TESTROOT/sbin/sourceInstallSiteConfFile.sh

# Menus functions
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl1-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl1-install-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl1-restore-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl1-rb-install.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl1-rb-restore.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl1-ui-install.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl1-ui-restore.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl1-config.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl2-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl3-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl3-ce-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl3-gdmp-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl3-rb-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl3-rc-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl3-rm-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl3-se-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl3-ui-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl3-wn-menu.sh
##. $EDG_TEST_FRAMEWORK/sbin/edg-lvl4-menu.sh
#


#############################
#                          #
# Exporting the functions #
#                        #
#########################
export -f add_list
export -f ceinfoprovcheck
export -f checkbrokerinfo
export -f checkenvvariable
export -f checkfiletofile_func
export -f checkglobusconfparam
export -f checkMD5filetofile_func
export -f checkmultipleservices
export -f checknfsmount
export -f checkopenport
export -f checkpathvar
export -f checkpathvar
export -f checkPBSenv
export -f checkPBSnodes
export -f checkPBSqueue
export -f checkPBSservername
export -f checkproxy
export -f checkroot
export -f checkservice_ps
export -f checkservice
export -f checkuserenv
export -f checkuser
export -f classify_rpms
export -f clean_list
export -f commonenv
export -f compare_list
export -f create_list
export -f dolist_install
export -f dolist_restore
export -f echo_success
export -f echo_failure
export -f echo_passed
export -f echo_warning
export -f echo_untested
export -f echo_xfail
export -f echo_unresolved
export -f print_status
export -f extractglobusconfparam
export -f fileexist
export -f findOpenssl
export -f getfileparamhead
export -f getfileparam
export -f getfileparamtail
export -f getglobusconfparam
export -f get_list
export -f getLogEnd_GDMP
export -f getLogID_GDMP
export -f getpkg_list
export -f getportnumber_etc_services
export -f getportnumber_netstat
export -f getrpmlist

export -f follow_progress
export -f check_step 
export -f check_title
export -f grep_info
export -f grep_info_title
export -f grep_info_brf
export -f grep_info_det
export -f grep_selected_info_det
export -f grep_selected_command
export -f grep_selected_step
export -f grep_selected_brf_info
export -f grep_selected_det_info
export -f grep_selected_substatus_info
export -f grep_selected_title
export -f insert_title
export -f print_info

export -f trace_status
export -f return_status


export -f grisqueryce
export -f grisqueryse
export -f HTML_echo 
export -f HTML_dump 
export -f HTML_cat 
export -f HTML_validate 
export -f HTML_create 
export -f inserttitleend
export -f inserttitlestart
export -f install_rpm
export -f loadVars
#export -f mail_success
#export -f mail_failure
export -f mail_status
export -f message
export -f randomfilecreate_func
export -f replace
export -f restore_list
export -f rpmcheckernilist
export -f rpmchecker
export -f runCommand_GDMP
export -f runCommand
export -f saveVars
export -f seinfoprovcheck
export -f sourceedgtestconffile
export -f sourceinstallsiteconffile
export -f sourcetestsiteconffile
export -f testrpm
export -f viewreport
export -f write_list
export -f writeOutput

export -f getpfileparamhead
export -f getpfileparamtail
export -f checkcron
export -f getparam_rb_conf
export -f getportnumber_rb_conf
