#
#  edg-tests  set-up
#
#   If you are using a borne-shell variant, you can cd to the directory
#   containing this file and source it.
#
#   The Testsuite is using a site configuration file 
#   to specify all the machines to be tested
#   
#   test_site-LocalTB.conf      Default Site configuration file 
#   test_site-LocalTB.template  Site configuration file template 
#   
#   See also  site configuration file already available for LCG sites. 
#   A site configuration file must be sourced.
#    
export EDG_FLAVOR="edg2"
export EDG_TESTROOT=`dirname $PWD`
install_dir=`dirname $EDG_TESTROOT`
export PATH="$EDG_TESTROOT/bin:$install_dir/bin:$PATH"
export PERLLIB="$install_dir/lib/perl"

alias lcg-site-test='def2log-script.sh -d $EDG_TESTROOT/tests/Others/Testbed_Test.def'
alias lcg-uiconfig-test='def2log-script.sh -d $EDG_TESTROOT/tests/InstallConfig/UI/UI_config_test.def'

if test -e $EDG_TESTROOT/etc/test_site-LocalTB.conf 
then
    echo "Using $EDG_TESTROOT/etc/test_site-LocalTB.conf"
else
    echo "A Local TestBed configuration file :"
    echo $EDG_TESTROOT"/etc/test_site-LocalTB.conf"
    echo "must be created from the available template file :"
    ls $EDG_TESTROOT/etc/test_site-LocalTB.template 
fi
