#!/bin/bash
# 
# 12/03/03
# Author:       Frederique Chollet chollet@lapp.in2p3.fr
# 
########################################################################
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
#######################################################################
# Verify CE Globus 2 Configuration - Compliant with EDG v1.4.x Installation Guide
# Document identifier : DataGrid-01-TED-0105-1-25
# 
# RETURN VALUE: 0 PASSED
#	 	1 FAIL
#		2 WARNING
#		3 XFAIL
#		4 UNRESOLVED
#		5 UNTESTED
#		6 UNSUPPORTED
#               7 ENVIRONMENT / OPTIONS FAIL
#	
########################################
# 
#
# INPUT none
#	
#	
########################################
#

function verifyCEGlobus2Conf()
{
	$ECHO -n "GLOBUS_LOCATION in "$GLOBUS_CONFIG >>$TMP_LOG_FILE 2>&1
	globus_location=`getglobusconfparam GLOBUS_LOCATION` && test "$globus_location" = "$GLOBUS_LOCATION"
   	trace_status
#
   	$ECHO -n "X509_USER_CERT in "$GLOBUS_CONFIG >>$TMP_LOG_FILE 2>&1
	x509_user_cert=`getglobusconfparam X509_USER_CERT` && test "$x509_user_cert" = "$SITE_DEF_HOST_CERT"    
 	trace_status
	$ECHO -n "X509_USER_KEY in "$GLOBUS_CONFIG >>$TMP_LOG_FILE 2>&1
	x509_user_key=`getglobusconfparam X509_USER_KEY`  && test "$x509_user_key" = "$SITE_DEF_HOST_KEY"        trace_status 
#
	$ECHO -n "GRIDMAP in "$GLOBUS_CONFIG >> $TMP_LOG_FILE 2>&1
	gridmap=`getglobusconfparam GRIDMAP` && test "$gridmap" = "$SITE_DEF_GRIDMAP" && fileexist $gridmap
	trace_status
#
	$ECHO -n "user in "$GLOBUS_CONFIG >>$TMP_LOG_FILE 2>&1
	user=`getglobusconfparam user` && checkuser $user
	trace_status
#
	return 

}
