#!/bin/bash
# 
# 05 Aout 2002
# Author:       Fede Eric fede@cppm.in2p3.fr
#
# Modify 02 october 2002 by Fede
# Modify 01.24.2003 by Frederique Chollet chollet@lapp.in2p3.fr
#
########################################################################
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
#######################################################################
# Control if the crl have the corresponding ca
# 
# RETURN VALUE: 0 PASSED
#	 	1 FAIL
#		2 WARNING
#		3 XFAIL
#		4 UNRESOLVED
#		5 UNTESTED
#		6 UNSUPPORTED
#               7 ENVIRONMENT / OPTIONS FAIL
#	
########################################
#
# INPUT $1 Complet path to CRL and CA directory (1 for the both path)
#	$2 Link to the openssl location
#	
#########################################
#

function verifyCRLversusCA_func()
{

if [ ! $1 ]; then
	writeOutput "ALERT verifyCRLversusCA-func function call without parameter" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;

	return 4;
fi

if [ ! $2 ]; then
	writeOutput "ALERT verifyCRLversusCA-func function call with the wrong number of parameter" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
	return 4;
fi

writeOutput "Test the CRLs versus the CAs" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;

nbcrl=0;			
for i in `ls $1/*.r0 2>/dev/null`; do
nbcrl=$[nbcrl+1];
done

#
if  [ $nbcrl -eq 0 ]; then 
	writeOutput "ALERT No CRL file find on $1" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;	
	return 4;
fi

for l in `ls $1/*.r0 2>/dev/null`; do

	$2 crl -in $l -noout -verify -CAfile ${l%.r0}.0 >& /tmp/$$_result;
	res=`$CAT /tmp/$$_result`;
	if [ "${res}" != "verify OK" ] ; then
		writeOutput "ALERT The CA "${l%.r0}" has not a valid CRL" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH

		return 1;
	fi
	$RM -f /tmp/$$_result;
				
done
return 0;
}
