#!/bin/bash
# 
# 05 Aout 2002
# Author:       Fede Eric fede@cppm.in2p3.fr
#
########################################################################
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
#######################################################################
# Test the host certificate
# 
# 
# RETURN VALUE: 0 PASSED
#	 	1 FAIL
#		2 WARNING
#		3 XFAIL
#		4 UNRESOLVED
#		5 UNTESTED
#		6 UNSUPPORTED
#               7 ENVIRONMENT / OPTIONS FAIL
#	
########################################
#
# INPUT $1 complet path to host cert
#	$2 path to the openssl binarie
#	
#
######################################

function verifyHostCertValidity_func()
{

if [ ! $1 ]; then
	writeOutput "ALERT verifyHostCertValidity-func function call without parameter" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH; 
	return 4;
fi

if [ ! $2 ]; then
	writeOutput "ALERT verifyHostCertValidity-func function call with the wrong number of parameter" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
	return 4;
fi


#writeOutput "Test the certificat" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH


# testing existense of file

if  fileexist $1 ; then
#
#	writeOutput "Your system is $datesys" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
	tlocal=`$DATE +%s`;
	$2 x509 -in $1 -startdate -noout >t1 ;
	$2 x509 -in $1 -enddate -noout >t2;
	$CUT -f2 -d= t1 >t11;
	$CUT -f2 -d= t2 >t21;
	i=`$CAT t11`;
	t12=`$DATE -d "$i" +%s`;
	i=`$CAT t21`;
	t22=`$DATE -d "$i" +%s`;
	$RM -rf t1;
	$RM -rf t2;
	$RM -rf t11;
	$RM -rf t21;
	if [ $t12 -lt $tlocal ] && [ $t22 -gt $tlocal ]; then
		writeOutput  "Your host certificat is valid on time" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
		return 0;
	else
		writeOutput "ALERT Your host certificat is not valid (out of time)" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
		return 1;
	fi

else
	writeOutput "ALERT The host certificate and/or key is not find on $1" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;	 
	return 4
fi
}
