#!/bin/bash
# 
# 31/01/03
# Author:       Frederique Chollet chollet@lapp.in2p3.fr
# 
########################################################################
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
#######################################################################
# Verify RB Globus Configuration - Compliant with EDG v1.4.x Installation Guide
# Document identifier : DataGrid-01-TED-0105-1-25
# 
# RETURN VALUE: 0 PASSED
#	 	1 FAIL
#		2 WARNING
#		3 XFAIL
#		4 UNRESOLVED
#		5 UNTESTED
#		6 UNSUPPORTED
#               7 ENVIRONMENT / OPTIONS FAIL
#	
########################################
# 
#
# INPUT none
#	
#	
########################################
#

function verifyRBGlobusConf()
{
   
	globus_location=`getglobusconfparam GLOBUS_LOCATION` && test "$globus_location" = "$GLOBUS_LOCATION"
   	trace_status
	
	globus_host_dn=`getglobusconfparam GLOBUS_HOST_DN`
 	trace_status 
	
        globus_org_dn=`getglobusconfparam GLOBUS_ORG_DN` && globus_org_dn="\""$globus_org_dn"\"" && test "$globus_org_dn" = "$SITE_DN"
	trace_status
	
        gridmapfile=`getglobusconfparam GRIDMAP` && test "$gridmapfile" = "$SITE_DEF_GRIDMAP"   
 	trace_status 

	gsiwuftpdport=`getglobusconfparam GSIWUFTPDPORT` && test $gsiwuftpdport = 2811
 	trace_status

	gsiwuftpdlog=`getglobusconfparam GSIWUFTPDLOG` 
 	trace_status

	globus_flavor_name=`getglobusconfparam GLOBUS_FLAVOR_NAME`
	trace_status 		

	x509_gatekeeper_cert=`getglobusconfparam X509_GATEKEEPER_CERT`  && test "$x509_gatekeeper_cert" = "$SITE_DEF_HOST_CERT"    
 	trace_status
	
	x509_gatekeeper_key=`getglobusconfparam X509_GATEKEEPER_KEY`  && test "$x509_gatekeeper_key" = "$SITE_DEF_HOST_KEY"    
	trace_status 

	x509_gsi_cert=`getglobusconfparam X509_GSIWUFTPD_CERT`&& test "$x509_gsi_cert" = "$SITE_DEF_HOST_CERT" 
 	trace_status

	x509_gsi_key=`getglobusconfparam X509_GSIWUFTPD_KEY` && test "$x509_gsi_key" = "$SITE_DEF_HOST_KEY"
 	trace_status
#
	return 

}
