#!/usr/bin/perl

use strict;
use Getopt::Std;

#p print STDERR " Parser Called with $ENV{STEPFILE} & @ARGV \n";

use vars qw/$opt_s $opt_i $opt_n $opt_l/;
getopts('l:s:in');

if ( $opt_n ) {
    my ($dum, $stepC) = split /\s+/, `/bin/grep STEPcount $ENV{STEPFILE}`;
    print "$stepC";
    exit 0;
}

if ( $opt_i ) {
# Summary info
    if ( defined $opt_s ) {
	my $step = $opt_s;
	++$step;
	print "Step $step";
	exit 0;
    }

# Global info
##old    for my $step ( 1..6 ) {
    for my $step ( 0 ) {
    my $match = "STEPinfo $step";
    my $next;
    open STEP, "$ENV{STEPFILE}";
    while (<STEP>) {
	if ( /$match/ ) {
##old	    print ">>Step $step ----------\n";
	    while ( ( $next = <STEP> ) !~ /^STEP/ ) {
##old	    while ( $next !~ /^STEP/ ) {
		print $next;
##old		$next = <STEP>;
	    }
	    print "\n";
	    last;
	}
    }
    close STEP;
}
    exit 0;
}

my $step = ++$opt_s;
my $arg1 = shift;
my $arg2 = shift;
my $match = "$step $arg1 $arg2";

print STDERR " Parser Running Step $step with $arg1 $arg2 \n";

if ( "$arg1" eq "$arg2" ) { exit 5; }
# 0 = OK
# 1 = FAIL
# 2 = WARNING
# 5 = UNTESTED

my $stepRef = ( $step > 3 ) ? 6 : 3;
my $rex = 5;
if ( ($step-3)*($step-6) != 0 ) {

    open STEP, "/bin/grep STEPend $ENV{STEPFILE} | ";
    while (<STEP>) {
#p    print;
	my @s = split /\s+/;
#p    if ( /$match/ ) { print "$match OK \n"; last; }
	if ( /$match/ ) { $rex = ( $s[4] ne "[OK]" ); 
			  print " Look to step $stepRef for this slot ! \n";
			  last; 
			}
    }
    close STEP;

} else {

    if ( $opt_l ) { open STDOUT, ">$opt_l" or die "Can't redirect stdout from Extractor \n"; }
    my $next;
    my $matchb = "STEPbegin $match";
#    my $matche = "STEPend $match";
    open STEP, "$ENV{STEPFILE}";
    while (<STEP>) {
	if ( /$matchb/ ) {
	    while ( ( $next = <STEP> ) !~ /^STEPend/ ) {
###	    while ( $next !~ /^STEPend/ ) {
		print $next;
###		$next = <STEP>;
	    }
	    my @s = split /\s+/, $next;
	    $rex = ( $s[4] ne "[OK]" );
	    last;
	}
    }
    close STEP;

}

exit $rex;
