#!/usr/bin/perl -w

## Author grodid 06/03/03
## Work in progress gg 29/11/04

use strict;
package BaseUtils;
#use Getopt::Long;
require Exporter;

use vars qw(@ISA @EXPORT);
@ISA = qw(Exporter);
@EXPORT = qw(importG switchStdout restoreStdout switchStdouterr restoreStdouterr addOption setContext checkArguments setDefaults TestProc DefProc editSiteConf checkProxyTime checkMyProxyTime printHelp printDesc buildCover buildRBconf buildTwig setGontext yob rob regression regrSetup createSSList);

use Config;
use FileHandle;
use File::Basename;

## For timeoutWithKill
use TestUtils;

use File::Temp "tempfile";

use Term::ANSIColor qw(:constants color colored);
use Getopt::Long qw(:config pass_through require_order no_ignore_case);

# $Id: BaseUtils.pm,v 1.1.1.2 2005/02/08 16:09:43 mbarroso Exp $

## To call GunTest ...
use FindBin qw($Bin);
##temp use lib "$Bin/cal-tests-new";
##temp use CalUtils;

use XML::Twig;

sub importG
{

## Temporary values
##  my ($shell, $script) = ("sh", "/home/grodid/CAL/create_conf/test_site.conf-grodid");
    my ($shell, $script) = @_;
#p  print STDOUT " Check: with $shell, sourcing $script \n";

    my $available;
    for (split /$Config{path_sep}/, $ENV{PATH})
    {
        $available = 1, last if -x "$_/$shell";
    }

    unless ($available)
    {
        print "1..0 #Skipped: $shell unavailable\n";
        return;
    }

    my $sh = Shell::Source->new(shell => $shell, file => $script);
    $sh->inherit;

}


sub editSiteConf {
    my ($self, $opt, @optList) = @_;
    $opt = substr($opt, 2);
    $opt =~ s/[T,P]Conf//;
    my @conf = `cat $MainScript::SiteConf`;
    my @confNew;
    print STDERR "\n EDIT: $opt \n";

    # Loop around all new options in the list ...
    foreach my $o ( @optList ) {
	my @m = split /=/, $o;
	my $key = $m[0];
##	my $stars = "";
	my $done = "";
	# lookup inside all records of the current Site Conf File ...
	foreach my $rec ( @conf ) {
	    my $stars = "";
	    chop $rec;
	    if ( $rec =~ /(\#*)export\s+(.*?)=(.*)/ ) {
##		$stars = "$1";
		my $k = $2;
		if ( $k eq $key ) { $rec = "#$rec"; $stars = "=$1=";  print STDERR " K $key $stars \n"; }  ## comment out and backup current record
	    }
	    ## reinsert record just read (and may be updated)
	    push @confNew, "$rec\n";
	    ## insert the new record right after the last alive one for the same key ...
	    if ( $opt eq "replace" ) { if ( $stars eq "==" ) { $done = "DONE"; push @confNew, "export $o\n"; }; }
	    if ( $opt eq "insert" ) { if ( $stars eq "==" )  { $done = "DONE"; push @confNew, "export $o\n"; }; }
	    if ( $opt eq "erase" ) { if ( $stars eq "==" )   { $done = "DONE"; push @confNew, "export $key=\" \" \n"; }; }
	} # end foreach $rec
	
	if ( $done ne "DONE" ) {
	if ( $opt eq "replace" ) { $done = "DONE"; push @confNew, "export $o\n"; }
	if ( $opt eq "insert" )  { $done = "DONE"; push @confNew, "export $o\n"; }
	if ( $opt eq "erase" )   { $done = "DONE"; push @confNew, "export $key=\" \" \n"; }
    }
	if ( $done eq "DONE" ) {
	    print STDERR " EDIT DONE: $opt with: $o \n";
	}
	# swap Conf files for next option lookup
	@conf = @confNew;
	@confNew = ();

    } # end foreach $o

    # write the file down ...
    open CFG, "> $MainScript::SiteConf";
    foreach my $rec ( @conf ) {
	print CFG $rec;
    }
    close CFG;

    return 0;

} # end subroutine


sub printHelp {
    my $rself = shift;
    my $self = $$rself;
    my $catreadme = shift;

##MC    my $readme = "$MainScript::DirMain"."/README-"."$MainScript::VERSION";
    my $readme = "$MainScript::DirBase"."/doc/README-MainScript";
    print "\n README file : $readme\n\n";
    system("cat $readme") if $catreadme;
    print "\n Available options (default): \n\n";
    for my $i (0 .. $#{$self->{optionLinkage}}) {
	print "$self->{optionLinkage}[$i] ($self->{optionDefaults}[$i]): $self->{optionDesc}[$i]\n";
    }
    print "\n";
    return 0;
}


sub printDesc {
    printHelp();
    return 0;
}


## To actually run a given test from the MainScript
sub TestProc {
  ## Arguments:
  # Title (string)
  # Prog to run (str)
  # Function to run (str)
  # test Index (int)
  # produce an HTML page (bool)
  # Nodes (str list)

  my ($rself, $title, $prog, $func, $index, $html, @nodesL) = @_;
    my $self = $$rself;
    my $test = $title;

  ## Specific for Regression Test
  if ( 1 ) {
          if ( $self->{rtest} ) { &regrSetup(\$self, $title, $index, "dum"); }
      } else {
  if ( $self->{rtest} ) {
#old      @ARGV = @{$self->{rtest}->{$test}};
      my $testKey = "${index}_${test}";
      @ARGV = @{$self->{rtest}->{$testKey}};
      $self->{opts} = {};
      my $error = checkArguments(\$self);
    # Check to see if an error occurred.
    if ($error) {
        print "ERROR in processing options.\n";
        printHelp( \$self );
        exit 1;
    }
      $error = setDefaults(\$self);
    # Check to see if an error occurred.
    if ($error) {
        print "ERROR in setting default option values.\n";
        printHelp( \$self );
        exit 1;
    }
      print " Special RTest: $error \n";
      print map { "   RTest $_ => $self->{opts}->{$_}\n" } sort keys %{$self->{opts}};
      print " Rtest Key: ${index}_${test} \n";
  }
}

  @nodesL = ("")  if ( ! $nodesL[0] );
  my $begin = " Begin test: $title with: $func on: @nodesL \n\n";
  print STDOUT $begin;
  my $result;
  my $globRes = "";
  my $tStart = time();
#  my $tmpoptv = "/tmp/optv";
  my ($handle, $tmpoptv) = tempfile("tmpoptvXXXXXX",
				   DIR => "/tmp/$ENV{USER}",
				   SUFFIX => '.optv');

 if ($prog eq "GunTest" ) {

## Most probably to be deprecated ...
     require 'CalUtils.pm';
#    my $fh = new FileHandle;
#    my $buffer = "";
#    $fh->setbuf($buffer);
#   $fh->open(">&STDOUT") or die "Can't redirect STDOUT to a BufferED area";
     my $tempf = "/tmp/$ENV{USER}-$$-Guntest";
     my $saveOut = switchStdout($tempf);
#wrong     @nodesL = split ( /\s+/, $nodesL[0] ) if ( $nodesL[0] );
     @nodesL = split ( /\s+/, $nodesL[0] ) if ( $#nodesL == 0 );
     CalUtils::GunTest ($func, @nodesL);
     restoreStdout($saveOut);
     $result = `cat $tempf`;
     unlink($tempf);
     print STDOUT $result;

 } else {

     ## Normal RunTest case ...

     ## Additive options processing ...
     if ( $self->{opts}->{addOptionList} || $self->{opts}->{forceMachineList} ) {
	 @nodesL = split ( /\s+/, $nodesL[0] ) if ( $#nodesL == 0 ); ## HumHum
	 my $pos = scalar(@nodesL)-1;
#p	 print " POS: $pos @nodesL \n";
	 my $i;
	 foreach my $j ( 0..$pos ) {
	     $i = $pos - $j;
#p	     print " I: $i $nodesL[$i] \n";
	     if ( substr($nodesL[$i], 0, 2) eq "--" ) { $i++; last; }
	 }
	 $pos = $i;
#p	 print " POS: $pos @nodesL \n";
	 if ( $self->{opts}->{forceMachineList} ) { 
	     splice (@nodesL, $pos);
	     push @nodesL, $self->{opts}->{forceMachineList};
	 } 
	 if ( $self->{opts}->{addOptionList} ) { splice (@nodesL, $pos, 0, $self->{opts}->{addOptionList}); }
     }
     if ( $self->{opts}->{addMachineList} ) { push @nodesL, $self->{opts}->{addMachineList}; }

     ## Filtering out repeated options ...
     @nodesL = filterOpts(@nodesL);
     print " After Filtering: @nodesL \n\n";

     if ( "$prog" eq "RunTest" ) { $prog = "edg-testbed-test"; }

     if ( $self->{opts}->{showME} ) { 
	 print STDOUT " Building Command: $prog $func @nodesL \n\n";
	 return 0;
     } elsif ( $self->{opts}->{fullHelp} ) { 
	 @nodesL = ("--help", "--desc");
	 print STDOUT " Helping Command: $prog $func @nodesL \n\n";
	 $result = `$prog $func @nodesL 2>&1`;
	 print STDOUT $result;
	 return 0;

     } else {

	 ## Actual command processing ...
	 print STDOUT " Processing Command: $prog $func @nodesL \n\n";
	 $self->{command}->{$test} = "Actual Command:\n\n $prog $func @nodesL";
	 @{$self->{options}->{$test}} = `$prog $func --help 2>&1`;
	 $self->{descrip}->{$test} = `$prog $func --desc 2>&1`;
##	 $self->{optvals}->{$test} = `$prog $func --optv 2>&1`;
	 ##old $result = `$prog $func @nodesL 2>&1`;
	 $result = "";
	 my $fail = 0;
	 my $timeout = 0;
	 my $pflag = $self->{opts}->{printDetails} || $self->{opts}->{verbose};
	 $self->{globalresult} = undef;

	 if ( $self->{opts}->{timeoutLapse} ) {

	     $ENV{EDG_TIMEOUT} = $self->{opts}->{timeoutLapse};

	     ## Processing with Forking and Timeout and Kill
	     my $command = "$prog $func @nodesL";
	     my $comadd  = "3>$tmpoptv";
	     my $href = timeoutWithKill( $command,
					 $self->{opts}->{timeoutLapse},
					 $self->{opts}->{timeoutSignal},
					 $comadd);
	     if ( $href->{rc} != 0 ) { $fail = 1; }
	     if ( $href->{rc} == -1 ) { $timeout = 2; }
	     my @reso = split /^/, $href->{out};
	     foreach ( @reso ) {
		 if ( /GLOBALRESULT/ ) {
#NO		     if ( $fail == 2 ) { next; }
		     my @m = split /\s+/, $_;
		     $globRes = $m[2];
		     $self->{globalresult} = $_;
#p		     print " GLOBALresult1: $self->{globalresult} \n";
		 } else {
		     if ( /error|fail|time out/i ) { $fail = 1; }
		     if ( /time out/i ) { 
#			 $globRes = "[TIMEOUT]"; 
#			 $self->{globalresult} =~ s/\[.*?\]/\[TIMEOUT\]/;
			 $timeout = 2;
#p			 print " GLOBALresult2: $self->{globalresult} \n";
		     }
		     ## Done in TestUtils instead
##NO ? 		     print;
		     $result .= $_;
		 }
	     }
	     if ( $timeout == 2 ) { 
		 $self->{globalresult} =~ s/\[.*?\]/\[TIMEOUT\]/; 
		 $globRes = "[TIMEOUT]"; 
	     }
#p	     print " GLOBALresult3: $self->{globalresult} \n";

	 } else {

	     ## Normal processing without any timeout
	 print STDOUT " [" unless $pflag;
	 open RESO, "$prog $func @nodesL 2>&1 3>$tmpoptv |";
	 while (<RESO>) {
#	     print;
#	     $result .= $_;
	     if ( /GLOBALRESULT/ ) {
		 my @m = split /\s+/, $_;
		 $globRes = $m[2];
		 $self->{globalresult} = $_;
# 		 $self->{global}->{"$func"}->{htmldir} = $m[4];
# 		 $self->{global}->{"$func"}->{htmlout} = $m[6];
	     } else { 
		 if ( /error|fail/i ) { 
		     print "\n", $result unless $pflag;
		     print; 
		     $pflag = 1;
		     $fail = 1;
		 }
		 else {
		     print if $pflag;  ##  $self->{opts}->{printDetails};
		     print STDOUT "." unless $pflag;
		 }
		 $result .= $_;
	     }
	 }
	 close RESO;
	 print STDOUT ">] \n" unless $pflag;

     }

	 if( ! $self->{globalresult} ) {
	 	if($fail) {
			$self->{globalresult} = "GLOBALRESULT = [ERROR]";
			if ( $globRes eq "" ) { $globRes = "[ERROR]"; }
		} else {
			$self->{globalresult} = "GLOBALRESULT = [UNKNOWN]";
			if ( $globRes eq "" ) { $globRes = "[UNKNOWN]"; }
		}
	 }
     }

 }

  my $tEnd = time();
  my $tElapse = $tEnd - $tStart;
  my $sElapse = $tElapse;
  $tElapse = " Duration: $tElapse sec.\n";
#  $self->{global}->{"$func"}->{duration} = $tElapse;
  $self->{optvals}->{$test} = `cat $tmpoptv 2>&1`;
  $self->{optvals}->{$test} .= &printOptv(\$self);
  unlink $tmpoptv;

  ##old print STDOUT $result;
  if ( $globRes ) { $globRes = colorGlob($globRes, $func); }
  if ( "@nodesL" =~ /NOXcute/ ) { undef $globRes; }  ##  Special RB_val
  my $end = "\n End Test #$index: $title with: $func on: @nodesL \n".
    "$globRes".
      "$tElapse".
	" ------------------------------------------------------------ \n";
  print STDOUT $end;

  if ( $html ) {
    my @page = ();
    my $ltit;
    ( $ltit = $title ) =~ s/\:+/_/g;
    $ltit =~ s/\s+/_/g;
    my $dirn = $ltit;
    my $hunc = $func;
    my @m = split /\:+/, $hunc;
    $hunc = $m[$#m];
    $hunc =~ s/\:+/_/g;
    $hunc =~ s/\s+/_/g;
    $ltit .= "-".$hunc;
    my $head = "<html>\n<head>\n<title> $ltit </title>\n";
    $head .= "</head>\n<body text=\"#000000\" bgcolor=\"#ffffff\">\n";
    $head .= "<h1>\n $ltit \n</h1>\n<pre>\n";
#    my $tail = "</pre>\n</body>\n</html>\n";
    my $help = "</pre>\n<h1>\n Description \n</h1>\n";
    my $hbody = `$prog $func --desc `;
    $hbody = "<pre>\n".$hbody."</pre>\n"; ## temp ?
    my $tail = "</body>\n</html>\n";

#    push @page, ($head, $begin, $result, $end, $tail);
    push @page, ($head, $begin, $result, $end, $help, $hbody, $tail);
    my $file = "$ENV{HTML_DIR}/$dirn";
    my $resmk = `mkdir -p $file`;
#    $file .= "/index.html";
    $file .= "/${hunc}.html";
#p    print " File: $file Func: $hunc \n";
    open HTM, ">$file";
    for my $p ( @page ) {
      print HTM $p;
    }
    close HTM;
    $index = sprintf("%02d", $index);
    $self->{global}->{"${index}_${ltit}"}->{htmldir} = "$ENV{HTML_DIR}/$dirn";
    $self->{global}->{"${index}_${ltit}"}->{htmlout} = "${hunc}.html";
    $self->{global}->{"${index}_${ltit}"}->{duration} = $sElapse;
    @m = split /\s+/, $self->{globalresult}; 
    $self->{global}->{"${index}_${ltit}"}->{result} = $m[2];
    $self->{global}->{"${index}_${ltit}"}->{command} = $self->{command}->{$test};
    $self->{global}->{"${index}_${ltit}"}->{descrip} = $self->{descrip}->{$test};
    $self->{global}->{"${index}_${ltit}"}->{options} = $self->{options}->{$test};
#good?    @{$self->{global}->{"${index}_${ltit}"}->{options}} = @{$self->{options}->{$test}};
    $self->{global}->{"${index}_${ltit}"}->{optvals} = $self->{optvals}->{$test};
    $self->{global}->{"${index}_${ltit}"}->{title} = $title;
    $self->{global}->{"${index}_${ltit}"}->{fulllog} = $result;
  } else {

    my $hunc = $func;
    my @m = split /\:+/, $hunc;
    $func = $m[$#m];

      @m = split /\s+/, $self->{globalresult}; 
      $m[4] =~ s/=//g;
    $index = sprintf("%02d", $index);
    my $findex = $index;
    my $safedir = "$ENV{HTML_DIR}/${findex}_${func}";
    rename $m[4], $safedir;
#old      $self->{global}->{"${index}_${func}"}->{htmldir} = $m[4];
      $self->{global}->{"${index}_${func}"}->{htmldir} = $safedir;
      $self->{global}->{"${index}_${func}"}->{htmlout} = $m[6];
      $self->{global}->{"${index}_${func}"}->{duration} = $sElapse;
      $self->{global}->{"${index}_${func}"}->{result} = $m[2];
      $self->{global}->{"${index}_${func}"}->{command} = $self->{command}->{$test};
      $self->{global}->{"${index}_${func}"}->{descrip} = $self->{descrip}->{$test};
      $self->{global}->{"${index}_${func}"}->{options} = $self->{options}->{$test};
      $self->{global}->{"${index}_${func}"}->{optvals} = $self->{optvals}->{$test};
      $self->{global}->{"${index}_${func}"}->{title} = $title;
      $self->{global}->{"${index}_${func}"}->{fulllog} = $result;
  }

  return 0;
}

## To actually run a given test from the MainScript thru def2log-script.sh
sub DefProc {
    ## Arguments:
    # Title (string)
    # def file (str)
    # test Index (int)

    my ($rself,  $title, $defFile, $index) = @_;
    my $self = $$rself;

    ## Specific for Regression Test
    if ( $self->{rtest} ) { &regrSetup(\$self, $title, $index); }

    my ($testName, $dir, $ext) = fileparse($defFile, '\..*');
    my $func = $testName;
    my $begin = " Begin test: $title with: $func \n\n";
    print STDOUT $begin;
    my $result;
    my $globRes = "";
    my $tStart = time();
    my $tempLog = "/tmp/$ENV{USER}-$$-$testName.log";
    my $htmlDir = "$ENV{HTML_DIRGG}/$testName";
    mkdir $htmlDir if ! -d $htmlDir;
    $result = `def2log-script.sh -x -d $defFile -l $tempLog`;
    my $stat = $?;

    open TED, "grep -A 1 'Test ending status is' $tempLog | ";
    while (<TED>) {
    	next unless /\[\s*([A-Z]+)\s*\]/;
	$globRes .= " [$1]";
    }
    close TED;

#p    print " Global Result: $globRes\n";
#    $result = `log2html-script.sh -f $htmlDir/index.html $tempLog`;
    $result = `log2html-script.pl -f $htmlDir/index.html $tempLog`;
    $stat = $?;
    my $tEnd = time();
    my $tElapse = $tEnd - $tStart;

    if ( $globRes ) { $globRes = extractGlob($globRes); }
#p    print " FUNC: ${func}_$index\n";
#    $self->{global}->{"${func}_$index"}->{htmldir} = "$ENV{HTML_DIRGG}";
    my $findex = sprintf("%02d", $index);
    $self->{global}->{"${findex}_${func}"}->{htmldir} = "$htmlDir";
    $self->{global}->{"${findex}_${func}"}->{htmlout} = "$testName";
    $self->{global}->{"${findex}_${func}"}->{duration} = $tElapse;
    $self->{global}->{"${findex}_${func}"}->{result} = $globRes;
    $self->{global}->{"${findex}_${func}"}->{command} = "Actual command:\n\n def2log-script.sh -x -d $defFile -l $tempLog";
    @{$self->{global}->{"${findex}_${func}"}->{options}} = `echo "Available options:" ; def2log-script.sh -h 2>&1`;
      $self->{global}->{"${findex}_${func}"}->{title} = $title;
      $self->{global}->{"${findex}_${func}"}->{fulllog} = `cat $tempLog`;
    $tElapse = " Duration: $tElapse sec.\n";
    my $descrip = `def2log-script.sh -i -d $defFile 2>&1`;
    $self->{global}->{"${findex}_${func}"}->{descrip} = $descrip;

    if ( $globRes ) { $globRes = colorGlob($globRes, $func); }
    my $end = "\n End Test #$index: $title with: $func \n".
      "$globRes".
	"$tElapse".
	  " ------------------------------------------------------------ \n";
    print STDOUT $end;

    return 0;
}


# A utility to temporarily switch the STDOUT to a file
sub switchStdout {
    local *FH;
    my ($file) = @_;
#p    print " Sending STDOUT to $file \n";
    open FH, ">&STDOUT" or die "Can't redirect STDOUT \n";
    open STDOUT, ">$file";
    select STDOUT; $|=1;
    return *FH;
}


# A utility to restore the STDOUT to its initial state
sub restoreStdout {
    local *FH;
    (*FH) = @_;
    close STDOUT;
    open STDOUT, ">&FH";
}

# A utility to temporarily switch the STDOUT and STDERR to a file
sub switchStdouterr {
    local *SAVEOUT;
    local *SAVEERR;
    my ($file) = @_;
#p    print " Sending STDOUT to $file \n";
    open SAVEOUT, ">&STDOUT" ;
    open SAVEERR, ">&STDERR" ;
    open STDOUT, ">$file" or die "Can't redirect STDOUT \n";
    open STDERR, ">&STDOUT" or die "Can't dup STDOUT \n";
    select STDERR; $|=1;
    select STDOUT; $|=1;
    my @fhl = (*SAVEOUT, *SAVEERR);
    return \@fhl;
}

# A utility to restore the STDOUT and STDERR to their initial state
sub restoreStdouterr {
    local *SAVEOUT;
    local *SAVEERR;
#    (*FH) = @_;
    my ($arrayref) = @_;
    (*SAVEOUT, *SAVEERR) = @$arrayref;
    close STDOUT;
    close STDERR;
    open STDOUT, ">&SAVEOUT";
    open STDERR, ">&SAVEERR";
}

## From Cal
# A utility method to add an option with description to the option
# list.  The default value is optional.  If specified and the user
# doesn't set a value the default will be used. The empty string is
# considered an undefined default. (See Getopt::Long description for
# proper syntax.)
sub addOption { 
    my ($rself, $tag, $desc, $default) = @_;
    my $self = $$rself;

    push @{$self->{optionLinkage}}, $tag;
    push @{$self->{optionDesc}}, $desc;
    if ($default) {
        push @{$self->{optionDefaults}}, $default;
    } else {
        push @{$self->{optionDefaults}}, '';
    }
    
#p    print " addOption @{$self->{optionLinkage}} \n";

}

## From Cal
# Process the command line arguments and set the defaults.
sub setDefaults {
    my $rself = shift;
    my $self = $$rself;

    print "MainScript: setDefaults\n";

    # Loop through all of the options. 
    for my $i (0 .. $#{$self->{optionDefaults}}) {

        my $default = ${$self->{optionDefaults}}[$i];
#p    print "Setting gefault $i = $default.\n";
        if ("$default" ne "") {
            my $linkage = ${$self->{optionLinkage}}[$i];
            $linkage =~ /([^=:!]+)([=:!].*)?/;
            my $option = $1;
            if (!($self->{opts}->{$option})) {
                print "Setting default $option = $default.\n";
                $self->{opts}->{$option} = $default;
            }
        }
    }

    return 0;
}

# A utility method to print current MainScript option values.
sub printOptv {
    my $rself = shift;
    my $self = $$rself;
#     my $text = $self->{HelpText} || "Empty help.\n";
#     print "\n$text\n";
##    open OPTV, ">&=3";
#good    my $string = "\nMainScript Effective options >value< (default): \n\n";
    my $string = "</pre>\n<h3>\n MainScript Effective options >value< (default): \n</h3><pre>\n";
    for my $i (0 .. $#{$self->{optionLinkage}}) {
#old	print "$self->{optionLinkage}[$i] ($self->{optionDefaults}[$i])\n     $self->{optionDesc}[$i]\n\n";
	my ($oname, $dum) = split /[!:=]/, $self->{optionLinkage}[$i];
	if ( $oname =~ /help|desc|optv/ ) { next; }
#	$string .= "--"."$oname"."=\t>$self->{opts}->{$oname}<"."\t($self->{optionDefaults}[$i])\n";
	my $value = $self->{opts}->{$oname} || "";
	$string .= "--"."$oname"."=\t>$value<"."\t($self->{optionDefaults}[$i])\n";
    }
    $string .= "---\n\n";
##    close OPTV;
    return $string;
}

## From Cal
# Process the command line arguments and check that they are
# sensible.  If not, raise an error. 
sub checkArguments {
    my $rself = shift;
    my $self = $$rself;

    print "MainScript: checkArguments\n";

    # Hand these off to the standard POSIX processor.
##    @ARGV = @{$self->{args}};
    my $result = &GetOptions(\%{$self->{opts}}, @{$self->{optionLinkage}});

    print " checkArguments @{$self->{optionLinkage}} \n";

    # Return an error flag if necessary.  (GetOptions returns 0 on error.)
    return (! $result);
}

## From Cal
# Subclasses should override this method if they wish to modify the
# context.  Typically can be used to set the HelpText and the DescText
# for the subclassed test.  Overridden methods should always call the
# parent's setContext method before any modifications are made. 
sub setContext {
    my $rself = shift;
    my $self = $$rself;

    print "MainScript: setContext\n";

    # Create the empty arrays for the option linkage, descriptions,
    # and defaults.
    $self->{optionLinkage} = [];
    $self->{optionDesc} = [];
    $self->{optionDefaults} = [];

    # Add the help and desc options.  Subclasses may add more
    # options if desired.
    if (1) {
    addOption($rself, "help",
		     "Print short help text.");
    addOption($rself, "desc",
		     "Print longer description of test.");
  }

}


# Same as above, but requires that the proxy will still be valid
# for the duration (hours) provided as 1st arg (def: 1 hour)
sub checkProxyTime {
    my $time = shift;
#    if ( $time eq "" ) { $time = 1; }
    $time ||= 1;
    my $trash = `grid-proxy-info -exists -h $time `;
    my $rc = $?;
    return $rc;
}

# Same as above, but for myproxy.
# Requires that the proxy will still be valid
# for the duration (hours) provided as 1st arg (def: 1 hour)
sub checkMyProxyTime {
    my $time = shift;
#    if ( $time eq "" ) { $time = 1; }
    $time ||= 1;
##    system("which myproxy-info");
    my $cmd   = "myproxy-info -s $ENV{PXhostname} -d | grep timeleft ";
    my $trash = `myproxy-info -s $ENV{PXhostname} -d | grep timeleft 2>&1`;
##    system("myproxy-info -s $ENV{PXhostname} -d 2>&1");
##    my $trash = `tcsh -c "/opt/globus/bin/myproxy-info -s $ENV{PXhostname} -d " `;
##    print " checkMyProxyTime: \n$cmd =$time= =$?=\n$trash\n";

    my $rc = $?;
    return $rc if $rc;

    my @m = split /\s+/, $trash;
    @m = split /:/, $m[2];

    return ($m[0] < $time);
}

# sub makeX {
#   my $str  = shift;
#   my $flag = shift;
#   return "<$flag>\n$str\n</$flag>\n";
# }

sub colorGlob {
    my ($globRes, $func) = @_;

    $func = sprintf ("%60s", $func);

      if ( $globRes eq "[OK]" ) {
	  $globRes = colored("OK", "green", "on_black", "bold");
      } else {
	  ($globRes) = $globRes =~ /^\[([A-Z]*)\]$/;
	  $globRes = colored("$globRes", "red", "on_black", "bold");
      }
      $globRes = " Global Result: \t".
	colored("$func", "yellow", "on_black", "bold").
	  " \t"."[$globRes]\n";

    return $globRes;
}

sub extractGlob {
    my $global = shift;

    $global =~ s/\s+//;
	## Try to find out what is available in $global ...
	## And compute (cook ?) an overall value ...
	my @m = split /\s+/, $global;
	my $result = 'OK';  ##  Default if nothing is "seen"
	foreach my $item ( @m ) {
	    if ( $item !~ /^\[[A-Z]*\]$/ ) { print STDERR " UGLY: =$item= \n"; next; }
	    $result = 'FAIL' unless ( $item eq '[OK]' );
	}

#p    print STDOUT " GLOBALRESULT: [$result]\n";
    return "[$result]";
}

sub regrSetup {
    my ($rself, $test, $index, $rbFlag) = @_;
    my $self = $$rself;

  ## Specific for Regression Test
  if ( $self->{rtest} ) {
#old      @ARGV = @{$self->{rtest}->{$test}};
      my $testKey = "${index}_${test}";
      @ARGV = @{$self->{rtest}->{$testKey}};

      if ( $ENV{TSTG_FORCINGTB} ) {
	  unshift @ARGV, "--forcingTB=$ENV{TSTG_FORCINGTB}";
      }
      if ( $ENV{TSTG_FORCINGVO} ) {
	  unshift @ARGV, "--forcingVO=$ENV{TSTG_FORCINGVO}";
      }
      if ( $ENV{TSTG_FORCINGRB} ) {
	  unshift @ARGV, "--forcingRB=$ENV{TSTG_FORCINGRB}";
      }

      if ( 0 ) {
      print " Special RTest: BEFORE $rbFlag \n";
      print map { "   RTest $_ => $self->{opts}->{$_}\n" } sort keys %{$self->{opts}};
      print " Rtest Key: ${index}_${test} \n";
  }

      if ( $rbFlag ne "RB_val" ) {
	  $self->{opts} = {};  ##  temp
      }

      my $error = checkArguments(\$self);
    # Check to see if an error occurred.
    if ($error) {
        print "ERROR in processing options.\n";
        printHelp( \$self );
        exit 1;
    }
      $error = setDefaults(\$self);
    # Check to see if an error occurred.
    if ($error) {
        print "ERROR in setting default option values.\n";
        printHelp( \$self );
        exit 1;
    }

      if ( $rbFlag ne "RB_val" ) {
      print " Special RTest: $error \n";
      print map { "   RTest $_ => $self->{opts}->{$_}\n" } sort keys %{$self->{opts}};
      print " Rtest Key: ${index}_${test} \n";
  }

  }
    return 0;
}

sub buildCover {
    my $rself = shift;
    my $self = $$rself;

    print "BaseUtils: buildCover\n";

    my $htmldir  = shift;
    my $mainName = shift;
    my $tAlmost  = shift;
    my $tarBall  = shift;
    my $dateST   = shift;
    my $dirGD    = shift;
    my $dirH     = shift;
    my $logName  = shift;
    my $siteTB   = shift;

    my $indexFile = "$htmldir/index.html";
    my $user = $ENV{USER};
#    chomp (my $date = `date '+%y%m%d-%T'` );
    my $date = $dateST;
    chomp (my $hostname = `hostname --long`);

    open HTM, ">$indexFile";
    my $testdate = $date;
    my $bigtitle = "$siteTB -- $user $date -- TSTG Functional Tests";
    my $subtitle = "Achieved from: $hostname with: $mainName";

#     print STDERR " Duration: $tAlmost \n";
#     print STDERR " TarBall in: $tarBall \n";
#     print STDERR " TimeStamp: $dateST \n";
#     print STDERR " LogFile in: $logName \n";
    my $oDuration =  "Test Overall Duration:     $tAlmost sec. ";
    my $oTarball  =  "TarBall available in file: $tarBall ";
#    my $oTimeStamp=  "Results available at URL:  http://grid-deployment.web.cern.ch/grid-deployment/tstg/$dirGD/$dirH ";
    my $oTimeStamp=  "Results available at URL: <a href=http://grid-deployment.web.cern.ch/grid-deployment/tstg/$dirGD/$dirH><b>http://grid-deployment.web.cern.ch/grid-deployment/tstg/$dirGD/$dirH</b></a>";
    my $oLogName = " ";
    if ( $logName !~ /^\/dev\/pt/ ) {
	mkdir "$htmldir/annex";
	my $resCP = `cp -p $logName $htmldir/annex/MainLog`;
#    my $oLogName  =  "Main Log File available in: <a href=\"HERE\"><b>http://grid-deployment.web.cern.ch/grid-deployment/tstg/$dirGD/$dirH/MainLog</b></a>";
	$oLogName  =  "Main Log File available in: <a href=annex/MainLog><b>HERE</b></a>";
    } else {
	$oLogName  =  "LogFile available in file: $logName ";
    }

    my $green = "#33ff33";
    my $red = "red";
    my $colord = "lightskyblue";  ##  "lavender";  ##  For Duration
    my $colort1 = "navajowhite";  ##  For RowTitle
    my $bodybgcolor = "#ffff99";       ##  was ...
    my $colorr1 = "coral4";
    my $colort2 = "orange";
    my $colort3 = "#FF8000";  ##  Is  "Mandarine";

    my $head = '
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>TSTG - TestDate</title>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
</head>
<body bgcolor="#ffffff" text="#000000" link="#0000ee" alink="#0000ee" vlink="#551a8b">
<h1 align="center">BigTitle</h1>
<h3 align="center">SubTitle</h3>
oDuration <br>
oTarball  <br>
oTimeStamp<br>
oLogName  <br>
<br>
';
# <h4 align="left">oDuration</h4>
# <h4 align="left">oTarball</h4>
# <h4 align="left">oTimeStamp</h4>
# <h4 align="left">oLogName</h4>
    my $tableBeg = '
<table cellpadding="2" cellspacing="2" border="4" width="80%" align="center">
<tbody>
<tr>
<th valign="top" align="center" bgcolor="palegreen">Row<br>Number</th>
<th valign="top" align="center" bgcolor="palegreen">Title</th>
<th valign="top" align="center" bgcolor="palegreen">Detailed<br>Results</th>
<th valign="top" align="center" bgcolor="palegreen">Main<br>Log File</th>
<th valign="top" align="center" bgcolor="palegreen">Detailed<br>Documentation</th>
<th valign="top" align="center" bgcolor="palegreen">Test<br>Duration</th>
</tr>
';
##prev2GOOD<th valign="top" align="center" bgcolor="palegreen">Command</th>
    my $tableRow = '
<tr>
<td valign="top" align="center" bgcolor="colorR">RowNumber</td>
<td valign="top" align="center" bgcolor="colorT">RowTitle</td>
<td valign="top" align="center"><a href="Anchor1">linkName1</a></td>
<td valign="top" align="center" bgcolor="colorS"><a href="AnchorF"><b>State1</b></a></td>
<td valign="top" align="center"><a href="AnchorO">linkNameO</a></td>
<td valign="top" align="right"  bgcolor="colorD">Time1</td>
</tr>
';
##prev2GOOD<td valign="top" align="center"><a href="AnchorC">linkNameC</a></td>
##prevGOOD <td valign="top" align="center" bgcolor="colorS"><b>State1</b></td>
    my $tableEnd = '
</tbody>
</table>
<br>
';
    my $tail = '
</body>
</html>
';

## $head: TestDate BigTitle SubTitle
## $tableBeg
## $tableRow: Anchor1 linkName1 colorS State1 Value1 colorT Time1 Other1  
## $tableEnd
## $tail

#     my $headt = $head;
#     $headt =~ s/TestDate/$testdate/;
    my $headt;
    ($headt = $head) =~ s/TestDate/$testdate/;
    $headt =~ s/BigTitle/$bigtitle/;
    $headt =~ s/SubTitle/$subtitle/;
    $headt =~ s/oDuration/$oDuration/;
    $headt =~ s/oTarball/$oTarball/;
    $headt =~ s/oTimeStamp/$oTimeStamp/;
    $headt =~ s/oLogName/$oLogName/;
    print HTM $headt;
    print HTM $tableBeg;
    my $rowN = 0;

    ## the main job indeed
    foreach my $test ( sort keys %{$self->{global}} ) {
#	chomp(my $list = `ls -1 $self->{global}->{$test}->{htmldir} | grep html`);
#ptest	print STDERR " GTMLDIR: $self->{global}->{$test}->{htmldir} \n";
	next unless ( -d $self->{global}->{$test}->{htmldir} );
	my @list = `cd $self->{global}->{$test}->{htmldir}; ls -1 *.html`;
#	next unless scalar(@list);
	next if $?;

	foreach my $litem ( @list ) {
	    chomp($litem);
	    if ( $litem ne "index.html" && $litem ne $self->{global}->{$test}->{htmlout} ) { next; }
	my $dir = basename($self->{global}->{$test}->{htmldir});
	print " Html: $test $self->{global}->{$test}->{htmldir} $dir $litem htmlout: $self->{global}->{$test}->{htmlout} \n";
	my $time = "$self->{global}->{$test}->{duration} sec";
	    $rowN++;
	my $rowT = "$self->{global}->{$test}->{title}";
	my $state = $self->{global}->{$test}->{result};
#	my $linkname = $self->{global}->{$test}->{htmldir}."/".$self->{global}->{$test}->{htmlout};
#	my $anchor = $self->{global}->{$test}->{htmlout};
	my $anchor = "$dir/$litem";
	my $linkname = "$test";
	my $colors = $green;
	$colors = $red if ( $state ne "[OK]" );
#	    my $colorr = "slateblue4";  ##  default for index column (1st one)
	    my $colorr = "lightblue";  ##  default for index column (1st one)
	    $colorr = $colorr1 if ( $rowT =~ /US_|JS_|MM_|_All|CE|RB|PXR|FTP|Storm/ );  ##  Main tests flagging ...
	    my $colort = $colort1;  ##  default for title column
	    $colort = $colort2 if ( $rowT =~ /DS_|GS_|RMC_|RMS_/ );  ##  Family grouping ...
	    $colort = $colort3 if ( $rowT =~ /MM_|CalStorm/ );  ##  Family grouping ...
	    mkdir "$dir/annex";
	    my $anchorF = "$dir/annex/${test}.fulllog";
#bad	    my $resF = `echo $self->{global}->{$test}->{fulllog} > $anchorF`;
	    open FLOG, "> $anchorF";
	    print FLOG "$self->{global}->{$test}->{fulllog}";
	    close FLOG;
	my $tr = $tableRow;
	$tr =~ s/RowTitle/$rowT/;
	$tr =~ s/RowNumber/$rowN/;
	$tr =~ s/Anchor1/$anchor/;
	$tr =~ s/linkName1/$linkname/;
	$tr =~ s/colorS/$colors/;
	$tr =~ s/colorD/$colord/;
	$tr =~ s/colorT/$colort/;
	$tr =~ s/colorR/$colorr/;
	$tr =~ s/State1/$state/;
	    $tr =~ s/AnchorF/$anchorF/;
	$tr =~ s/Time1/$time/;
	    if ( $self->{global}->{$test}->{command} ) {
#prev		mkdir "$dir/annex";
		my $anchorC = "$dir/annex/${test}.command";
#bad		my $resC = `echo $self->{global}->{$test}->{command} > $anchorC`;
		open FLOG, "> $anchorC";
		print FLOG "$self->{global}->{$test}->{command}";
		close FLOG;
		my $linknameC = "command";
		$tr =~ s/AnchorC/$anchorC/;
		$tr =~ s/linkNameC/$linknameC/;
		my $anchorO = "$dir/annex/${test}.options";
#		my $resO = `echo $self->{global}->{$test}->{options} > $anchorO`;
		my @strip = optStrip($self->{global}->{$test}->{options});
		open OPT, ">$anchorO";
#good		print OPT @{$self->{global}->{$test}->{options}};
		print OPT "<html><body>\n";
		print OPT "</pre>\n<h1 style=\"color:blue;\">\n Description \n</h1>\n";
		print OPT "<pre>\n";
#GOOD		$self->{global}->{$test}->{descrip} =~ s/^BaseTest: setContext[\S\s]* ---EndSettingDefaults\n//;
		$self->{global}->{$test}->{descrip} =~ s/[\S\s]* ---EndSettingDefaults\n//;
		print OPT $self->{global}->{$test}->{descrip};
		print OPT "</pre>\n";
		print OPT "</pre>\n<h1 style=\"color:magenta;\">\n Actual command used for this execution \n</h1>\n";
		print OPT "<pre>\n";
		print OPT $self->{global}->{$test}->{command};
		print OPT "</pre>\n";
		print OPT "</pre>\n<h1 style=\"color:cyan;\">\n Effective Option Values\n</h1>\n";
		print OPT "<pre>\n";
		print OPT $self->{global}->{$test}->{optvals};
		print OPT "</pre>\n";
		print OPT "</pre>\n<h1>\n Available Options \n</h1>\n";
		print OPT "<pre>\n";
		print OPT @strip;
		print OPT "</pre>\n";
		print OPT "</html></body>\n";
##    $hbody = "<pre>\n".$hbody."</pre>\n"; ## temp ?
		close OPT;
		my $linknameO = "Description";
		$tr =~ s/AnchorO/$anchorO/;
		$tr =~ s/linkNameO/$linknameO/;
	    }
	print HTM "$tr";
    }
    }

    print HTM $tableEnd;
    print HTM $tail;
    close HTM;

    return "$indexFile";

}

sub buildTwig {

    my $rself = shift;
    my $self = $$rself;

    print "BaseUtils: buildTwig\n";

    my $htmldir  = shift;
    my $mainName = shift;
    my $tAlmost  = shift;
    my $tarBall  = shift;
    my $dateST   = shift;
    my $dirGD    = shift;
    my $dirH     = shift;
    my $logName  = shift;
    $rself = shift;
    my %prevENV = %{$rself};
    $rself = shift;
    my %aftENV = %{$rself};

    my @diff = ();
    foreach ( keys %aftENV ) {
	push @diff, $_ unless exists $prevENV{$_};
    }

    my $xmlFile = "$htmldir/summary.xml";
    my $user = $ENV{USER};
#    chomp (my $date = `date '+%y%m%d-%T'` );
    my $date = $dateST;
    chomp (my $hostname = `hostname --long`);

    open XTM, ">$xmlFile";
    my $testdate = $date;
    my $bigtitle = "$user $date -- TSTG Functional Tests";
    my $subtitle = "Achieved from: $hostname with: $mainName";

#     print STDERR " Duration: $tAlmost \n";
#     print STDERR " TarBall in: $tarBall \n";
#     print STDERR " TimeStamp: $dateST \n";
#     print STDERR " LogFile in: $logName \n";
    my $oDuration =  "Test Overall Duration:     $tAlmost sec. ";
    my $oTarball  =  "TarBall available in file: $tarBall ";
    my $oTimeStamp=  "Results available at URL:  http://grid-deployment.web.cern.ch/grid-deployment/tstg/$dirGD/$dirH ";
    my $oLogName  =  "LogFile available in file: $logName ";

    my $root = XML::Twig::Elt->new('html'); ##   pretty_print' => 'record');
    my $body = XML::Twig::Elt->new('body');
    $body->paste($root);

    foreach my $test ( sort keys %{$self->{global}} ) {

	## Some filtering for very special cases (historical ?)
	next unless ( -d $self->{global}->{$test}->{htmldir} );
	my @list = `cd $self->{global}->{$test}->{htmldir}; ls -1 *.html`;
	next if $?;
	foreach my $litem ( @list ) {
	    chomp($litem);
	    if ( $litem ne "index.html" && $litem ne $self->{global}->{$test}->{htmlout} ) { next; }

	my $link = XML::Twig::Elt->new('test');
#?	$link->paste('last_child', $body);
# 	$link->set_att('href', $self->{global}->{$test}->{htmldir});
# 	$link->set_att('duration', $self->{global}->{$test}->{duration});
# 	$link->set_text($self->{global}->{$test}->{title});
 	$link->set_text("$test");
	my @m = keys %{$self->{global}->{$test}};
	print " TLink: $test @m \n";
	my $eltX;
	foreach my $sub1 ( keys %{$self->{global}->{$test}} ) {
#TEMP	    if ( $sub1 =~ /fulllog|descrip|options|optvals/ ) { next; }
	    my $val = $self->{global}->{$test}->{$sub1};
	    if ( ref($self->{global}->{$test}->{$sub1}) eq 'ARRAY' ) { $val = "@{$self->{global}->{$test}->{$sub1}}"; }
#p	    print " sLink: $sub1 $val \n";
	    print " sLink: $sub1 \n";
#	    my $lsub1 = XML::Twig::Elt->new("$sub1", $self->{global}->{$test}->{$sub1});
	    my $lsub1 = XML::Twig::Elt->new("$sub1");
#	    $lsub1->set_text($self->{global}->{$test}->{$sub1});
	    if ( $sub1 eq 'optvals' ) {
#		my $elt = XML::Twig::Elt->parse("<pre> blob \n $val\n</pre>");
		$val =~ s/[<>]//g;
		my $elt = XML::Twig::Elt->parse("<textopt> $val \n </textopt>");
		$elt->paste('last_child', $lsub1);
	    } elsif ( $sub1 eq 'ghtmldir' ) {  ##  most probably useless
		my $file = "$self->{global}->{$test}->{htmlout}";
		$file =~ s/=//g;
		$file = "$val"."/$file";
		my $elt = XML::Twig::Elt->new("twig_roots");
		$elt->parsefile("$file");
		$elt->paste('last_child', $lsub1);
	    } elsif ( $sub1 eq 'fulllog' ) {
		$lsub1->set_text($val);
		my @l = grep { /log2html/ } split /\n/, $val;
		#p print " ll: $l[0] \n";
		if ( @l ) {
		    @l = split " ", $l[0];
		    print " llll: $l[-1] \n";
		    my $file = $l[-1];
		    open HTM, "cat $file | sed -e's/<br>//g' |";
# 		    my $elt = XML::Twig::Elt->new();
# 		    $elt->parse(\*HTM);
my $str = "";
while (<HTM>) {
    if ( /^\s*<.*>$/ ) { $str .= $_; }
    else {
		$_ =~ s/&/&amp;/g; # This must be changed first.
		$_ =~ s/\"/&quot;/g;
    		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
	$str .= $_;
    }
}
#GOOD		    $eltX = XML::Twig::Elt->parse(\*HTM);
		    $eltX = XML::Twig::Elt->parse($str);
		    close HTM;
#		    $eltX->paste('last_child', $lsub1);
		}
	    } else {
		$lsub1->set_text($val);
	    }
	    $lsub1->paste('last_child', $link);
	    print " SLink: $sub1 \n";
	}
	if ( $eltX ) {
	    my $lsub1 = XML::Twig::Elt->new("xmlmatrix");
#	    $eltX->paste('last_child', $lsub1);
	    $eltX->paste($lsub1);
	    $lsub1->paste('last_child', $link);
	    print " SLink: xmlmatrix \n";
	}
	
	$link->paste('last_child', $body);
    }
    }
    my $link = XML::Twig::Elt->new('environment');
#    foreach my $sub1 ( keys %ENV ) {
    foreach my $sub1 ( sort @diff ) {
	my $lsub1 = XML::Twig::Elt->new("$sub1");
	$lsub1->set_text("$ENV{$sub1}");
	$lsub1->paste('last_child', $link);
    }
    $link->paste('last_child', $body);
    print " RRoot: $XML::Twig::VERSION $root \n";
    $root->print(\*XTM, 'record');
    close XTM;
    undef $root;

    return "$xmlFile";

}

sub setGontext {

    my $self = shift;
    $self = $$self;

# For storing actual options provided by the user
    $self->{opts} = {};
# Definition of options
    setContext( \$self );
# Add some options
    addOption (\$self, "TList=s", 
	       "To Provide a list of Tests to be achieved");
#	       "DNS");
    addOption (\$self, "TGroup:s", 
	       "To Provide a Group Name of Tests to be achieved", 
	       "SiteTesting");
#    addOption (\$self, "MList=s", "To Provide a list of Machines to be tested");
    addOption (\$self, "TUser", 
	       "To force tstgrp as the Default User for I&C tests");
    addOption (\$self, "MDebug", 
	       "To print some Variable values from inside the MainScript");
    addOption (\$self, "List", 
	       "To list all available test names");
    addOption (\$self, "fullHelp", 
	       "To Force printing some Help about the selected Tests.\n\tDoes not achieve any actual test.");
#p    print " TSTG Forcing, got >$ENV{TSTG_FORCINGTB}< >$ENV{TSTG_FORCINGVO}< \n";
    my $ldef = "dteam";
    $ldef = $ENV{TSTG_FORCINGVO} if $ENV{TSTG_FORCINGVO};
    addOption (\$self, "forcingVO:s", 
	       "To Force a VO other than =dteam=", 
	       "$ldef");
#	       "To Force a VO other than =tstg=", "tstg");
    $ldef = "LocalTB";
    $ldef = $ENV{TSTG_FORCINGTB} if $ENV{TSTG_FORCINGTB};
    addOption (\$self, "forcingTB:s", 
	       "To Force a TB other than =CertTB=\n\tPossible choices are: LCG0 LCG1 tstgTB DevTB CertTB LCG0.1 LocalTB", 
	       "$ldef");
    addOption (\$self, "regFile=s", 
	       "To Provide a file to be used for the Regression Test (works for RTest only)");
    addOption (\$self, "addOptionList=s", 
	       "To Provide a list of additionnal Options to the Tests to be achieved.\n\tThey will override the default ones.");
    addOption (\$self, "forceMachineList=s", 
	       "To Provide a space separated list of Machines to be used in the tests,\n\toverriding the default ones");
    addOption (\$self, "addMachineList=s", 
	       "To Provide a space separated list of Machines to be used in the tests,\n\tadding them to the default ones");
    addOption (\$self, "showME", 
	       "To Force printing of option values and machine names for the selected Tests.\n\tDoes not achieve any actual test.");
    addOption (\$self, "forceSubItem=i", 
	       "To Force execution of only one subitem of the selected Tests.");
#	       1);
    addOption (\$self, "verbose!", 
	       "To Force printing of moderate output when processing tests.", 
	       0);
    addOption (\$self, "dohtml!", 
	       "To Force the build of an HTML summary from the log output (UTest case only).", 
	       0);
    addOption (\$self, "printDetails", 
	       "To Force printing of moderate output when processing tests.");
    addOption (\$self, "forcingRB=s", 
	       "To force the submission and all edg-job-* commands to go thru this RB.\n\tThis will fully override the default one.");
    if (0) {
    addOption (\$self, "rbVal=i", 
	       "To Select the RB node rank within the RB_val test. Useless otherwise.");
}
    if (0) {
    addOption (\$self, "glueSchema", 
	       "To Force using GLUE schema when selecting CEs");
}
    addOption (\$self, "RBjFact=i", 
	       "Repeat factor in the RB_val test, to specify the overall number of jobs.",
	       1);
    addOption (\$self, "twig", 
	       "To Create an XML summary file using Twig.");

    addOption (\$self, "timeoutLapse=i",
	       "To process a given Test with Fork and Timeout and Kill (seconds)");
    addOption (\$self, "timeoutSignal=i",
	       "Type of Signal used during the Fork and Timeout and Kill",
	       9);

##    addOption (\$self, "cksumSize:i", "Size of the file for checksum test (Mb)", 2000);
    ## For SiteConf file management/editing
##    addOption (\$self, "insertTConf=s", "To insert temporarily a list of new machine names in the SiteConf file. Ex:\n--insertConf=\"MDShostname=lxxx01.cern.ch BDIIhostname=lcg01.in2p3.fr\" ");
##    addOption (\$self, "replaceTConf=s", "To replace temporarily a list of machine names within the SiteConf file. Ex:\n--replaceConf=\"MDShostname=lxxx01.cern.ch BDIIhostname=lcg01.in2p3.fr\" ");
##    addOption (\$self, "eraseTConf=s", "To erase temporarily a list of machine names from the SiteConf file. Ex:\n--eraseConf=\"MDShostname BDIIhostname\" ");
##    addOption (\$self, "insertPConf=s", "To insert permanently a list of new machine names in the SiteConf file. Ex:\n--insertConf=\"MDShostname=lxxx01.cern.ch BDIIhostname=lcg01.in2p3.fr\" ");
##    addOption (\$self, "replacePConf=s", "To replace permanently a list of machine names within the SiteConf file. Ex:\n--replaceConf=\"MDShostname=lxxx01.cern.ch BDIIhostname=lcg01.in2p3.fr\" ");
##    addOption (\$self, "erasePConf=s", "To erase permanently a list of machine names from the SiteConf file. Ex:\n--eraseConf=\"MDShostname BDIIhostname\" ");
    # Process the command line arguments.
    my $error = checkArguments(\$self);
    # Check to see if an error occurred.
    if ($error) {
        print "ERROR in processing options.\n";
        printHelp( \$self );
        exit 1;
    }
    # Set any defaults for parameters not set by user.
    $error = setDefaults(\$self);
    # Check to see if an error occurred.
    if ($error) {
        print "ERROR in setting default option values.\n";
        printHelp( \$self );
        exit 1;
    }
    # If the help or desc was requested, print that then return.
    printHelp( \$self, 1 ) if ($self->{opts}->{help});
    printDesc() if ($self->{opts}->{desc});
    exit 0 if (($self->{opts}->{help}) || ($self->{opts}->{desc}));

    $self->{opts}->{forcingVO} =~ s/\s+/,/g;
    $self->{opts}->{forcingVO} = qq/$self->{opts}->{forcingVO}/;

    print "\n";
    for my $k ( keys %{$self->{opts}} ) {
	print " Options: $k $self->{opts}->{$k} \n";
    }

    return 0;

}

sub yob {
    my $text = shift;
    $text = colored("$text", "yellow", "on_black", "bold");
#    $text = colored("$text", "yellow", "on_black");
    return $text;
}

sub rob {
    my $text = shift;
    $text = colored("$text", "red", "on_black", "bold");
#    $text = colored("$text", "red", "on_black");
    return $text;
}

sub optStrip {
    my $href = shift;
    my @strip = ();
    my $flag;
    foreach my $i ( @$href ) {
	if ( $i =~ /^Available/ ) {
	    $flag = 1;
	    push @strip, $i;
	} elsif ( $flag ) {
	    if ( $i =~ /^help|^desc|^optv/ ) { next; }
	    ##nomore if ( $i =~ /^resource|^rank|^requirements|^njobs|^nstreams|^retrycount|^myproxyhost/ ) { next; }  
	    push @strip, $i;
	    if ( $i =~ /^---/ ) { last; }
	}
    }
    return @strip;
}

sub filterOpts {
    my @nodesL = @_;
    @nodesL = split /\s+/, "@nodesL";
    my $nodeH = {};
    my @newL = ();
    my @optL = ();
    foreach my $item ( @nodesL ) {
#p	print " Item: $item \n";
#g1	my ($opt, $val) = $item =~ /^--(\w+)=??(\w*?)$/;
	my ($opt, $val) = $item =~ /^--(\w+)=?(\S*?)$/;
	if ( $opt ) {
#p	    print " Parse: $opt -> $val \n";
	    if ( ! $nodeH->{$opt} ) { push @optL, $opt; }
	    $nodeH->{$opt} = $item;
	} else {
	    push @newL, $item;
	}
    }
#good    my @vals = values %{$nodeH};
    my @vals = map { $nodeH->{$_} } @optL;
    print " Vals: @vals \n";
#good    @newL = (values %{$nodeH}, @newL);
    @newL = (@vals, @newL);
    return @newL;
}

sub buildRBconf {
    my $self = shift;
    $self = $$self;
    my @RBs = split (/,/, shift);

    if ( $ENV{EDG_FLAVOR} eq "edg2" ) {
    my $configVO  = "/opt/edg/etc/dteam/edg_wl_ui.conf";
    my $configVAR = "/opt/edg/etc/edg_wl_ui_cmd_var.conf";
    if ( ! ( -e $configVO && -e $configVAR ) ) {
	return 1;
    }
    my @VO  = `cat $configVO`;
    my @VAR = `cat $configVAR`;
    my @NS = grep /NSAddresses/, @VO;
    $NS[0] =~ /\"(.*):7772/;
    my $rbNS = $1;
    my @LB = grep /LBAddresses/, @VO;
    $LB[0] =~ /\"(.*):9000/;
    my $rbLB = $1;
    my @LD = grep /LoggingDestination/, @VAR;
    $LD[0] =~ /\"(.*):9002/;
    my $rbLD = $1;
    if ( ! ( $rbNS eq $rbLB && $rbLB eq $rbLD ) ) {
	return 1;
    }
    
    foreach my $rbname ( @RBs ) {
	my $voname  = "$ENV{EDG_TESTROOT}/etc/broker_conf/edg_wl_ui-"."$rbname".".conf";
	my $varname = "$ENV{EDG_TESTROOT}/etc/broker_conf/edg_wl_ui_cmd_var-"."$rbname".".conf";
	if ( ! -e $voname ) {
	    my $rcs = `sed -e's/$rbNS/$rbname/g' $configVO > $voname`;
	    print STDERR " Created VO  RB conf file: $voname Status: $rcs \n";
	}
	if ( ! -e $varname ) {
	    my $rcs = `sed -e's/$rbNS/$rbname/g' $configVAR > $varname`;
	    print STDERR " Created VAR RB conf file: $varname Status: $rcs \n";
	}
    }

## New for gLite case

    } elsif ( $ENV{EDG_FLAVOR} eq "glite1" ) {
	my $configVO  = "$ENV{EDG_TESTROOT}/etc/broker_conf/glite_vo.template";
	my $configVAR = "$ENV{EDG_TESTROOT}/etc/broker_conf/glite_var.template";
	if ( ! ( -e $configVO && -e $configVAR ) ) {
	    return 1;
	}
	my @VO  = `cat $configVO`;
	my @VAR = `cat $configVAR`;
	my $lbname = $ENV{LBhostname};
#	my $voname = "BID"; ##  $self->{opts}->{forcingVO};
	my $voname = $self->{opts}->{forcingVO};
	foreach my $rbname ( @RBs ) {
	    my $vorname  = "$ENV{EDG_TESTROOT}/etc/broker_conf/edg_wl_ui-$rbname-$lbname-$voname.conf";
	    my $varname = "$ENV{EDG_TESTROOT}/etc/broker_conf/edg_wl_ui_cmd_var-$rbname-$lbname-$voname.conf";
	    if ( ! -e $vorname ) {
# 		foreach my $l ( @VO ) {
# 		    print  STDOUT "VOR0 $l";
# 		}
#NO		@VO  = map { s/RBNAME/$rbname/g; } map { s/LBNAME/$lbname/g; } map { s/VONAME/$voname/g; } @VO;
#NO		@VO  = map { s/RBNAME/UUU/g } @VO;
#good		@VO  = map { $_ = $_; } @VO;
		open VOR, ">$vorname";
		foreach my $l ( @VO ) {
		    $l =~ s/RBNAME/$rbname/g;
		    $l =~ s/LBNAME/$lbname/g;
		    $l =~ s/VONAME/$voname/g;
		    print  VOR "$l";
#p		    print  STDOUT "VOR1 $l";
		}
		close VOR;
		print STDERR " Created VO  RB conf file: $vorname \n";
	    }
	    if ( ! -e $varname ) {
#NO		@VAR = map { s/RBNAME/$rbname/g; } map { s/LBNAME/$lbname/g; } map { s/VONAME/$voname/g; } @VAR;
		open VAR, ">$varname";
		foreach my $l ( @VAR ) {
		    $l =~ s/RBNAME/$rbname/g;
		    $l =~ s/LBNAME/$lbname/g;
		    $l =~ s/VONAME/$voname/g;
		    print  VAR "$l";
		}
		close VAR;
		print STDERR " Created VAR RB conf file: $varname \n";
	    }
	    $self->{fRBS}->{$rbname}->{$lbname}->{$voname}->{VOR} = $vorname;
	    $self->{fRBS}->{$rbname}->{$lbname}->{$voname}->{VAR} = $varname;
	}
    }

    return 0;
}

sub createSSList {
    foreach my $var ( sort keys %ENV ) {
#p	print " Key: $var \n";
	if ( $var =~ /^(\w+hostname)_$/ ) {
	    my $varB = "$1";
	    my $varS = "$1"."__";
#p	    print " >> VAR: $varB";
	    my @m = split /,/, $ENV{$var};
	    $ENV{$varS} = "@m";
	    if ( $ENV{$varB} ) { 
#p		print " $ENV{$varB}"; 
	    } else {
		$ENV{$varB} = $m[0];
	    }
#p	    print " $ENV{$var} \n";
	}
    }
    ## Verification ...
    foreach my $var ( sort keys %ENV ) {
	if ( $var =~ /hostname/ ) {
#p	    print " HNAME: $var $ENV{$var} \n";
	}
    }
    return;
}

sub regression {
    my ($rself, $file) = @_;
    my $self = $$rself;

    my @tList;
    local *RTF;

    if ( -e $file ) {
	open RTF, "<$file";
    } else {
	*RTF = *DATA;
    }

     while (<RTF>) {
#    while (<DATA>) {

	## Skip what looks like a comment
	if ( /^#|^\n/ ) { next; }

	chomp;

	my @m = split /MainScript /, $_;
	push @tList, $m[1];
    }
     close RTF;
#    close DATA;

	  my $in = 0;
        @{$self->{rtestl}} = ();
    foreach my $test ( @tList ) {
	my @m = ();
#p	print "\n ARGS: @ARGV \n";
	print " test: $test \n";

	## Parsing the options ...
	my @ext = $test =~ m{
	    (--\w+(?:=").+?")            # to match addOptionList & forceMachineList
	     | (--\w+?=\S+)              # to match forcingTB & TList (or S instead of 2nd w ?)
	     | (--\w+)                   # to match showME and verbose
		}gx;

# This solution may be useful in case of parsing the opt/val pairs
#	    push (@ext, $+) while $test =~ m{
#		(--\w+(?:=").+?")            # to match addOptionList & forceMachineList
#		 | (--\w+?=\S+)              # to match forcingTB & TList (or S instead of 2nd w ?)
#		 | (--\w+)                   # to match showME and verbose
#	     }gx;

#	push @m, @ext;

	    ## Cross-checking ... and filtering out undef values ;;-
	    my $nn = 0;
#p	    print " Seen Options: \n";
	    foreach my $i ( @ext ) {
		if ( ! $i ) { next; }
		push @m, $i;
#p		print " $nn =>> >$i< \n";
		$nn++;
	    }
	    print "\n";

	## Extracting the testName ... and removing the doubleQuotes
	my @argList = ();
	my $testName = "";
	foreach my $p ( @m ) {
	    if ( $p =~ /TList=(.+)\s*/ ) {
		$testName = $1;
		print " testName: =$testName= \n";
	    } else {
		$p =~ s/\s+$//;
##		if ( $p =~ /MachineList/ ) { $p =~ s/"//g; }
		$p =~ s/"//g; 
		push @argList, $p;
	    }
	}

        ## Filling the lists for the MainScript working loop ...
        $in++;
        my $testKey = "${in}_${testName}";
	print " ARGL: $testKey @argList \n";
	@{$self->{rtest}->{$testKey}} = @argList;
        push @{$self->{rtestl}}, $testName;

    }
    return;
}

1;

__DATA__
##opt/edg/bin/MainScript --forcingTB=CertTB --TList=CEGate --forceMachineList="lxshare0235.cern.ch"
##opt/edg/bin/MainScript --forcingTB=CertTB --TList=CECycle --addOptionList="--reqLapse=5 --maxSubs=2 --maxStack=25 --singleSubmit" --verbose --forceMachineList="lxshare0235.cern.ch lxshare0241.cern.ch" --showME

opt/edg/bin/MainScript --forcingTB=CertTB --TList=CEGate --forceMachineList="lxshare0235.cern.ch lxshare0241.cern.ch lxshare0277.cern.ch"
opt/edg/bin/MainScript --forcingTB=CertTB --TList=CECycle --addOptionList="--reqLapse=5 --maxSubs=2 --maxStack=25 --singleSubmit" --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=UI_ST --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=FTP_ST --forceMachineList="lxshare0235.cern.ch lxshare0241.cern.ch" --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=DNS --forceMachineList="lxshare0235.cern.ch lxshare0241.cern.ch lxshare0277.cern.ch"
opt/edg/bin/MainScript --forcingTB=CertTB --forcingVO=dteam --TList=RB --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --forcingVO=dteam --TList=RLS
opt/edg/bin/MainScript --forcingTB=CertTB --TList=RMCycle --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=SEwsCycle --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=MM --addOptionList="--keepTempDir --oneStep" --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=MM_file --addOptionList="--oneStep --execute --singleSubmit" --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=MM_gridftp --addOptionList="--oneStep --execute --protocol=gridftp --singleSubmit" --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=MM_rfio --addOptionList="--oneStep --execute --protocol=rfio --singleSubmit" --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=MDS --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=JStorm --addOptionList="--keepTempDir --reqLapse=5 --maxSubs=2 --maxStack=25 --singleSubmit --useCEList" --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=JS_sleep --addOptionList="--reqLapse=5 --maxSubs=2 --maxStack=25 --singleSubmit --useCEList --batchSleep=60" --verbose
opt/edg/bin/MainScript --forcingTB=CertTB --TList=CStorm --addOptionList="--reqLapse=5 --maxSubs=2 --maxStack=25 --singleSubmit"
opt/edg/bin/MainScript --forcingTB=CertTB --TList=RStorm --addOptionList="--maxsubs=2"
opt/edg/bin/MainScript --forcingTB=CertTB --TList=KStorm --addOptionList="--maxSubs=2 --cksumSizeMb=2 --singleSubmit"
opt/edg/bin/MainScript --forcingTB=CertTB --TList=DStorm --addOptionList="--vo=dteam --useCEList --singleSubmit --maxSubs=2"
opt/edg/bin/MainScript --forcingTB=CertTB --TList=US_script --addOptionList="--reqLapse=2 --maxSubs=2 --useCElist --customScript=opt/edg/tests/etc/config_tests_conf/my.script"
opt/edg/bin/MainScript --forcingTB=CertTB --verbose --TList=US_jdl --addOptionList="--reqLapse=5 --maxSubs=2 --singleSubmit --customJDL=opt/edg/tests/etc/config_tests_conf/my.jdl"

#opt/edg/bin/MainScript --forcingTB=CertTB --TList=DNS --forceMachineList="lxshare0235.cern.ch lxshare0241.cern.ch lxshare0277.cern.ch" --showME
#opt/edg/bin/MainScript --forcingTB=CertTB --TList=DNS --forceMachineList="lxshare0235.cern.ch lxshare0241.cern.ch lxshare0277.cern.ch" --fullHelp

#opt/edg/bin/MainScript --forcingTB=CertTB --TList=MM --addOptionList="--oneStep" --forceMachineList="lxshare0236.cern.ch lxshare0291.cern.ch lxshare0278.cern.ch"
#opt/edg/bin/MainScript --forcingTB=CertTB --TList=MM_file --addOptionList="--oneStep --execute" --forceMachineList="lxshare0236.cern.ch lxshare0291.cern.ch lxshare0278.cern.ch" --showME
#opt/edg/bin/MainScript --forcingTB=CertTB --verbose --TList=US_jdl --addOptionList="--reqLapse=44 --maxSubs=33 --singleSubmit --customJDL=opt/edg/tests/etc/config_tests_conf/my.jdl" --forceMachineList="lxshare0235.cern.ch lxshare0241.cern.ch lxshare0277.cern.ch" --showME
