#!/usr/bin/perl

my ($timeout,$command) = @ARGV;

die "Usage: Two arguments needed <timeout sec> <command>\n" if (!defined $timeout || ! defined $command);

my $href = mytimeout($command, $timeout); 

# Print output into stdout
print $href->{out};

# Exit with the launched command return code:
exit $href->{rc};

# A utility function to execute a given command with a timeout
sub mytimeout {
  my ($command, $timeout) = @_;
  $timeout ||= 240;

  my $rc = 0;
  my $output = '';

  my $r = rand;

  eval {
    local $SIG{ALRM} = sub {die "time out\n"};
    alarm $timeout;
    $output = `$command 2>&1`;
    $rc = $? >> 8;
    alarm 0;
  };

  if ($@) {
    die unless $@ eq "time out\n";   # propagate unexpected errors
    # timed out
    $rc = -1;
    print "Command timed out\n";
  }

  return { rc=>$rc, out=>$output};

}
