<?xml version="1.0" encoding="ISO-8859-1"?>
<!--
XSLT stylesheet to view XML logs in web browser (tested with Mozilla 1.5)
Author: Andrey Kiryanov <Andrey.Kiryanov@cern.ch>

$Id: log.xsl,v 1.2 2005/04/20 10:46:20 diana Exp $
 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>
<xsl:template match="/log">
<html><head><title><xsl:value-of select="/log/info/title"/></title></head><body>
<xsl:call-template name="info"/>
<xsl:call-template name="table"/>
<xsl:call-template name="descs"/>
</body></html>
</xsl:template>
<xsl:template name="info">
<div style="background:white;text-align:center;">
<xsl:if test="/log/info/title"><h1 style="color:blue;"><xsl:value-of select="/log/info/title"/></h1></xsl:if>
<xsl:if test="/log/info/host"><p>Test run on: <b><xsl:value-of select="/log/info/host"/></b></p></xsl:if>
<xsl:if test="/log/info/date"><p>Test run date: <b><xsl:value-of select="/log/info/date"/></b></p></xsl:if>
</div>
</xsl:template>
<xsl:template name="table">
<div style="background:white;"><table style="margin:auto;border-collapse:collapse;" cellpadding="10">
<tr><th colspan="2"></th>
<xsl:for-each select="/log/info/cols_list/col">
<th style="border:1px solid;" colspan="2"><xsl:value-of select="."/></th>
</xsl:for-each>
</tr>
<xsl:for-each select="/log/info/rows_list/row">
<xsl:variable name="row"><xsl:value-of select="position()"/></xsl:variable>
<tr>
<td style="border:1px solid;text-align:right;white-space:nowrap;">
<xsl:for-each select="/log/info/step">
<a style="text-decoration:none;" href="#desc{position()}"><xsl:value-of select="./brf_info"/></a>
<xsl:if test="position() != last()"><br/></xsl:if>
</xsl:for-each>
</td>
<th style="border:1px solid;"><xsl:value-of select="/log/info/rows_list/row[number($row)]"/></th>
<xsl:for-each select="/log/info/cols_list/col">
<xsl:variable name="col"><xsl:value-of select="position()"/></xsl:variable>
<xsl:choose>
<xsl:when test="/log/row">
<td style="border:1px solid;text-align:center;white-space:nowrap;">
<xsl:for-each select="/log/row[number($row)]/col[number($col)]/step">
<xsl:call-template name="result"><xsl:with-param name="res"><xsl:value-of select="./retval"/></xsl:with-param></xsl:call-template>
<xsl:if test="position() != last()"><br/></xsl:if>
</xsl:for-each>
</td><td style="border:1px solid;text-align:center;white-space:nowrap;">
<xsl:for-each select="/log/row[number($row)]/col[number($col)]/step">
<xsl:choose>
<xsl:when test="./substatus">
<xsl:value-of select="./substatus"/>
</xsl:when>
<xsl:otherwise>
<xsl:text>&#8212;</xsl:text>
</xsl:otherwise>
</xsl:choose>
<xsl:if test="position() != last()"><br/></xsl:if>
</xsl:for-each>
</td>
</xsl:when>
<xsl:when test="/log/col">
<td style="border:1px solid;text-align:center;white-space:nowrap;">
<xsl:for-each select="/log/col[number($col)]/row[number($row)]/step">
<xsl:call-template name="result"><xsl:with-param name="res"><xsl:value-of select="./retval"/></xsl:with-param></xsl:call-template>
<xsl:if test="position() != last()"><br/></xsl:if>
</xsl:for-each>
</td><td style="border:1px solid;text-align:center;white-space:nowrap;">
<xsl:for-each select="/log/col[number($col)]/row[number($row)]/step">
<xsl:choose>
<xsl:when test="./substatus">
<xsl:value-of select="./substatus"/>
</xsl:when>
<xsl:otherwise>
<xsl:text>&#8212;</xsl:text>
</xsl:otherwise>
</xsl:choose>
<xsl:if test="position() != last()"><br/></xsl:if>
</xsl:for-each>
</td>
</xsl:when>
</xsl:choose>
</xsl:for-each>
</tr>
</xsl:for-each>
</table></div>
</xsl:template>
<xsl:template name="result">
<xsl:param name="res"/>
<xsl:choose>
<xsl:when test="number($res) = 0">
<span style="color:green;background:lightgreen;"><xsl:text>PASSED</xsl:text></span>
</xsl:when>
<xsl:when test="number($res) = 1">
<span style="color:red;background:yellow;"><xsl:text>FAIL</xsl:text></span>
</xsl:when>
<xsl:when test="number($res) = 2">
<span style="color:blue;background:yellow;"><xsl:text>WARNING</xsl:text></span>
</xsl:when>
<xsl:when test="number($res) = 3">
<span style="color:red;background:yellow;"><xsl:text>XFAIL</xsl:text></span>
</xsl:when>
<xsl:when test="number($res) = 4">
<span style="color:black;background:darkgrey;"><xsl:text>UNRESOLVED</xsl:text></span>
</xsl:when>
<xsl:when test="number($res) = 5">
<span style="color:black;background:darkgrey;"><xsl:text>UNTESTED</xsl:text></span>
</xsl:when>
<xsl:when test="number($res) = 6">
<span style="color:black;background:darkgrey;"><xsl:text>UNSUPPORTED</xsl:text></span>
</xsl:when>
<xsl:otherwise>
<span style="color:black;background:white;"><xsl:text>&#8212;</xsl:text></span>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
<xsl:template name="descs">
<div>
<h1 style="text-align:center;color:blue;"><xsl:text>Tests descriptions</xsl:text></h1>
<xsl:for-each select="/log/info/step">
<p><b><a name="desc{position()}"><xsl:value-of select="./brf_info"/><xsl:text>:</xsl:text></a></b></p>
<pre><xsl:value-of select="./det_info"/></pre>
</xsl:for-each>
</div>
</xsl:template>
</xsl:stylesheet>
