#!/bin/bash
# 
# 04 december 2002
# Author:       Fede Eric fede@cppm.in2p3.fr
#
#########################################################################
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
#######################################################################
# Control the MD5 correspondance between file
# 
# RETURN VALUE: 0 PASSED
#	 	1 FAIL
#		2 WARNING
#		3 XFAIL
#		4 UNRESOLVED
#		5 UNTESTED
#		6 UNSUPPORTED
#               7 ENVIRONMENT / OPTIONS FAIL
#	
########################################
#
# INPUT  $1 The path to file1
#	 $2 The path to file2
# 
# 
########################################

function checkMD5filetofile_func()

{

if [ ! $1 ]; then
	writeOutput "ALERT checkMD5filetofile-func function call without parameter" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH
	return 4;
fi

if [ ! $2 ]; then
	writeOutput "ALERT checkMD5filetofile-func function call without paramete" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;

fi

if  fileexist $2 ; then

md5sum $1 > result;
$CUT -f1 -d/ result >result1;
re1=`$CAT result1`;
$RM -f result;
md5sum $2 > result;
$CUT -f1 -d/ result >result2;
re2=`$CAT result2`;
$RM -f result;
$RM -f result1;
$RM -f result2;

if test "$re1" = "$re2" ; then
		return 0;
	else
		return 1;
	fi
fi
return 1;
} 
