#!/bin/bash

##################################################################################
#
# Authors: Mario Reale    -  Mario.Reale@cnaf.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
# Modified : TSTG 15/01/03 F.Chollet chollet@lapp.in2p3.fr 
#                          temporary files handling
###################################################################################
# FUNCTION: checkopenport <variable>
#
# ARGUMENTS: <variable> {string} (mandatory)
#
# DESCRIPTION: check if a given port is used by a process in the  LISTENING status
#
# RETURN VALUE: 0 - if <service> is defined (value in output)
#		1 - if <service> is not defined
#               4 - if no mandatory parameter is passed  
####################################################################################


function checkopenport() {

 if [ -z $1 ]
   then
        [ $DEBUG ] && $ECHO "checkopenport(): no mandatory parameter is passed"
	return 4
   fi

   cc=$1

   netstat -nalpv 2> /dev/null | grep $cc | grep LISTEN > /tmp/checkopenport_dummyfile1_$$ 
   res=`tail /tmp/checkopenport_dummyfile1_$$ | awk 'BEGIN { FS = ":" }  $0  ~ // {print $2} '  | awk 'BEGIN { FS = " " }  $0  ~ // {print $1} '`

   netstat -nalpv 2> /dev/null | grep $cc   | grep LISTEN > /tmp/checkopenportdf_$$
   pippo=`tail /tmp/checkopenportdf_$$ | awk 'BEGIN { FS = "/" }  $0  ~ // {print $2}'`  

   rm /tmp/checkopenport_dummyfile1_$$
   rm /tmp/checkopenportdf_$$

   if [ $res ]
   then
       [ $DEBUG ] && $ECHO -e "checkopenport(): port  $1 is used by process $pippo in LISTENING"   
    #    $ECHO $res2
        return 0
   else
		[ $DEBUG ] && $ECHO "checkopenport(): there are no processes listening on port $1 "
        $ECHO ""
        return 1
   fi


}




