#!/bin/bash
#$Id: checkPBSnodes.sh,v 1.1.1.2 2005/02/08 16:09:44 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: checkPBSnodes
#
# ARGUMENTS: none
#
# RETURN VALUE: 0 - if all is configured properly
#               1 - if there are some errors
##################################################################

checkPBSnodes()
{
   for WN in $WNhostnames	
   do
	local WNhostname=`$ECHO $WN | $CUT -d':' -f1`
	local shortWNhostname=`$ECHO $WN | $CUT -d':' -f1 | $CUT -d'.' -f1`

	local CPUnum=`$ECHO $WN | $CUT -d':' -f2`

	local PBSstr="$WNhostname np=$CPUnum"
	local shortPBSstr="$shortWNhostname np=$CPUnum"

	local match=`$GREP -w "$PBSstr" /usr/spool/PBS/server_priv/nodes > /dev/null; $ECHO $?`
	local shortmatch=`$GREP -w "$shortPBSstr" /usr/spool/PBS/server_priv/nodes > /dev/null; $ECHO $?`

	if [ $match -ne 0 ] && [ $shortmatch -ne 0 ]; then
		return 1
	fi

   done

   return 0

}
