#!/bin/bash
#$Id: checkPBSqueue.sh,v 1.1.1.2 2005/02/08 16:09:44 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: checkPBSqueue
#
# ARGUMENTS: none
#
# RETURN VALUE: 0 - if all is configured properly
#               1 - if there are some errors
##################################################################

checkPBSqueue()
{
   
   cequeue=`getfileparam CE_QUEUE /etc/edg/info-mds.conf`

   if [ -z $cequeue ]; then
	return 1
   fi

   cequeue=`$ECHO $cequeue | $SED "s/,/ /g"`   

   for queue in $cequeue
   do
	local val=`$QSTAT -Q $queue &> /dev/null; $ECHO $?`
	if [ $val -ne 0 ]; then
		return 1
	fi

   done

   return 0
}
