#!/bin/bash
######################################################################
#
# Authors: Antonio Forte   - Antonio.Forte@to.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: checkservice_ps <service>
#
# ARGUMENTS: <service> {string} (mandatory)
#
# DESCRIPTION: check if <service> is running using ps command
#
# RETURN VALUE: 0 - if <service> is running 
#               1 - if <service> is not running 
#               4 - no mandatory parameter is passed
##################################################################

checkservice_ps()
{
   if [ -z $1 ]
   then
        [ $DEBUG ] && $ECHO "checkservice_ps(): no mandatory parameter is passed"
	return 4
   fi

   local status

status=`ps -efw | $GREP -w $1 | $GREP -v "grep" | $WC -l` 
   if [ $status != 0 ]
   then
  	[ $DEBUG ] && $ECHO "checkservice_ps(): service $1 is running"
	return 0
   else
	[ $DEBUG ] && $ECHO "checkservice_ps(): service $1 is NOT running"
	return 1
  fi

}
