#!/bin/sh
#
######################################################################
#
# Authors: Andrea Formica   - Andrea.Formica@cea.fr
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
# Based on INFN Testgroup scripts
#
######################################################################

##################################################################
# FUNCTION: compare-list <flag> <input file>
#
# ARGUMENTS: <list1>    {string} (mandatory)
#            <list2>    {string} (mandatory)
#
# Input:  <list>        Compare two lists  
#                             
#
#
# RETURN VALUE: 0 - lists are equal
#               1 - lists are differents
#	        4 - no mandatory parameter is passed
#
##################################################################
#
compare_list()
{

    local THIS_SCRIPT="compare-list.sh"
    local HOUR=`date | awk '{print $4}'`
    local PRETXT="$PRESTRING [${THIS_SCRIPT} ${HOUR}]:"

    if [ -z "$1" ]
    then
        [ $DEBUG ] && writeOutput "compare-list(): no mandatory parameter is passed"
        [ $DEBUG ] && writeOutput "$THIS_SCRIPT: input  $1={list1}"
        echo
	return 4
    fi
    if [ -z "$2" ]
    then
        [ $DEBUG ] && writeOutput "compare-list(): no mandatory parameter is passed"
        [ $DEBUG ] && writeOutput "$THIS_SCRIPT: input  $2={list2}"
        echo
	return 4
    fi
    
    local l="$1"
    local m="$2"

    for mrpm in $l; do
        isthere=`echo $m | egrep -i $mrpm`
        [ $? != 0 ] && return 1
    done
    for mrpm in $m; do
        isthere=`echo $l | egrep -i $mrpm`
        [ $? != 0 ] && return 1
    done

    return 0
}
