######################################################################
#
# Authors: Mario Reale     -      Mario.Reale@cnaf.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

##################################################################
# FUNCTION: getfileparamtail <filename>
#
# ARGUMENTS: <filename> {string} (mandatory)
#            <query string> (string) (mandatory)
#
# DESCRIPTION: check if a parameter is defined inside a file.
#               if multiple lines found, last line ("tail") is
#               considered
#
# RETURN VALUE: 0 - if <query string> found in <filename>
#               1 - if <query string> not fond in <filename>
#               4 - no mandatory parameter is passed
##################################################################


#!/bin/bash

getfileparamtail()
{
   if [ -z $1 ]
   then
        $ECHO "getfileparamtail(): no mandatory parameter is passed"
        return 4
   fi

   if [ -z $2 ]
   then
        $ECHO "getfileparamtail(): no mandatory parameter is passed"
        return 4
   fi

 what=$2;
 where=$1;

 a=`grep $what $where | awk 'BEGIN { FS < $what }; $0 ~ // {print $2}'  | head -1`


   if [ "$a" ]
         then
         b=`expr length $a`
        
        if  [ "$b"=1 ]
            then
             a=`grep $what $where | awk 'BEGIN { FS < $what }; $0 ~ // {print $3}' | tail -1`
             b=`expr length $a`;
         fi

         c=`expr index $a =`
         d=`expr $b - $c`
         f=`expr $c + 1`
         e=`expr substr $a $f $b`
        	$ECHO "getfileparamtail(): param " $2 " is inside file $1 as $e" 
	        return 0
       else
        	$ECHO "getfileparamtail(): param "$2"  is NOT defined in file "  $1 " !"
   	        return 1

     fi

}
