#!/bin/bash
#$Id: getGlobusConfParam.sh,v 1.1.1.2 2005/02/08 16:09:44 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone   - Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################


##################################################################
# FUNCTION: getglobusconfparam <variable>
#
# ARGUMENTS: <variable> {string} (mandatory)
#
# DESCRIPTION: check if <variable> is defined in /etc/globus.conf
#	       and returns value
#
# RETURN VALUE: 0 - if <variable> is defined (value in output)
#		1 - if <variable> is not defined 
#	        4 - no mandatory parameter is passed
##################################################################
# Modified F.C Use $GLOBUS_CONFIG if defined

getglobusconfparam()
{
   if [ -z $1 ]
   then
        [ $DEBUG ] && $ECHO "getglobusconfparam(): no mandatory parameter is passed" 1>&2
	return 4
   fi
   if [ -z "$GLOBUS_CONFIG" ] 
   then    
	source $EDG_TEST_GLCF > /dev/null 2>&1
   else
	source $GLOBUS_CONFIG > /dev/null 2>&1
   fi
   
  
   local varname=$1
   eval local varvalue=$`$ECHO $1`

   if [ "$varvalue" ]
   then
	[ $DEBUG ] && $ECHO "getglobusconfparam(): variable is defined ($varname = $varvalue)" 1>&2
	$ECHO "$varvalue"
	return 0
   else
	[ $DEBUG ] && $ECHO "getglobusconfparam(): variable $varname is NOT defined!" 1>&2
   	$ECHO ""	
	return 1
   fi
}
