#!/bin/sh
#
######################################################################
#
# Authors: Andrea Formica   - Andrea.Formica@cea.fr
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
# Based on INFN Testgroup scripts
#
######################################################################

##################################################################
# FUNCTION: restore-list <list 1> <list 2>
#
# ARGUMENTS: <list 1>    {string} (mandatory)
#            <list 2>    {string} (mandatory)
#
# Input:  <list 1>       Clean strings listed in <list 2> from <list 1> 
#                          
#                             
#
# RETURN VALUE: 0 - list 1 cleaned
#               1 - nothing to clean
#	        4 - no mandatory parameter is passed
#
##################################################################
#
restore_list()
{

    PRESTRING="${PRESTRING}+"
    local THIS_SCRIPT="restore-list.sh"
    local HOUR=`date | awk '{print $4}'`
    local PRETXT="[${THIS_SCRIPT} ${HOUR}]:"
    
    if [ $LEVEL -gt 1 ]
    then
        PRETXT="$PRESTRING [${THIS_SCRIPT} ${HOUR}]:"
    fi

    if [ "$1" = "" ] 
    then
        [ $DEBUG ] && writeOutput "restore-list(): no mandatory parameter is passed"
        [ $DEBUG ] && writeOutput "$THIS_SCRIPT: input  $1={list 1}"
        PRESTRING=`echo ${PRESTRING} | $CUT -c 2-`
	return 4
    fi
    if [ "$2" = "" ] 
    then
        [ $DEBUG ] && writeOutput "restore-list(): no mandatory parameter is passed"
        [ $DEBUG ] && writeOutput "$THIS_SCRIPT: input  $2={list 2}"
        PRESTRING=`echo ${PRESTRING} | $CUT -c 2-`
	return 4
    fi

    
    local mlist="$1"
    local rlist="$2"
    local isthere=""

    RPMLIST=""
    [ $DEBUG ] && writeOutput "${PRETXT} Got lists"
    [ $DEBUG ] && writeOutput "${PRETXT} ==$mlist=="
    [ $DEBUG ] && writeOutput "${PRETXT} ==$rlist==" 

    for mname in $mlist; do    
        isthere=`echo $rlist | egrep $mname`
        if [ "$isthere" != "" ]; then
           [ $DEBUG ] && writeOutput "${PRETXT} $mname is in list 2"
        else
            RPMLIST="$RPMLIST $mname"
        fi
    done
    [ $DEBUG ] && writeOutput "${PRETXT} Giving RPMLIST " 
    [ $DEBUG ] && writeOutput "${PRETXT} ==$RPMLIST=="

    [ $DEBUG ] && writeOutput "${PRETXT} ### END" 
    PRESTRING=`echo ${PRESTRING} | $CUT -c 2-`
    
    return 0
}
