#! /usr/bin/env bash
###############################################################
###############################################################
##
##              SOURCE EDG-TEST.CONF FILE
##    
###############################################################
###############################################################
##
## Author: Metery Rene - CS-SI (FRANCE)
##         rene.metery@c-s.fr
## Date: December 19th 2002
## Last modification : December 19th 2002
## Version: 1.0
## Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
##     http://www.edg.org/license.html or see LICENSE file
##
###############################################################
###############################################################
##
## FUNCTION: sourceedgtestconffile
## ARGUMENTS: none
##
## DESCRIPTION: source the user edg-test.conf file if
##              it exists or source the edg-test.conf
##              file at its default location.
##              
## EXIT CODE: 0 - file sourced
##            
###############################################################
###############################################################

sourceedgtestconffile()
{
 DIRECTORY=$HOME/.edg-tsft
 FILENAME=edg-test.conf
 
 ### Directory $DIRECTORY exists ? ###
 if test -d $DIRECTORY
 then
       ### Yes
       ### File $DIRECTORY/$FILENAME exists ?
       if test -e $DIRECTORY/$FILENAME
       then
             ### Yes
             . $DIRECTORY/$FILENAME
	     [ $DEBUG ] && $ECHO "sourceedgtestconffile(): $DIRECTORY/$FILENAME file sourced"
             return 0
       else
             ### No
             . $EDG_TESTROOT/etc/edg-test.conf
	     [ $DEBUG ] && $ECHO "sourceedgtestconffile(): $EDG_TESTROOT/etc/edg-test.conf file sourced"
             return 0
       fi
 else
       ### No
       . $EDG_TESTROOT/etc/edg-test.conf
       [ $DEBUG ] && $ECHO "sourceedgtestconffile(): $EDG_TESTROOT/etc/edg-test.conf file sourced"
       return 0
 fi
}