#! /usr/bin/env bash
###############################################################
###############################################################
##
##              SOURCE INSTALL_SITE.CONF FILE
##    
###############################################################
###############################################################
##
## Author: Metery Rene - CS-SI (FRANCE)
##         rene.metery@c-s.fr
## Date: December 19th 2002
## Last modification : December 19th 2002
## Version: 1.0
## Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
##     http://www.edg.org/license.html or see LICENSE file
##
###############################################################
###############################################################
##
## FUNCTION: sourceinstallsiteconffile <component>
##
## ARGUMENTS: component {string} (mandatory)
##
## DESCRIPTION: source the user install_site.conf file if
##              it exists or source the install_site.conf
##              file at its default location.
##
## EXIT CODE: 0 - file sourced
##            4 - no mandatory parameter is passed
##            
###############################################################
###############################################################

sourceinstallsiteconffile()
{
 DIRECTORY=$HOME/.edg-tsft
 FILENAME=install_site.conf

 if [ -z $1 ]
 then
       [ $DEBUG ] && $ECHO "sourceinstallsiteconffile(): no mandatory parameter is passed"
       return 4
 fi

 ### Directory $DIRECTORY exists ? ###
 if test -d $DIRECTORY
 then
       ### Yes
       ### File $DIRECTORY/$FILENAME exists ?
       if test -e $DIRECTORY/$FILENAME
       then
             ### Yes
             . $DIRECTORY/$FILENAME
             [ $DEBUG ] && $ECHO "sourceedgtestconffile(): $DIRECTORY/$FILENAME file sourced"	     
             return 0
       else
             ### No
             . $EDG_INSTALL_SITE_CONF
	     [ $DEBUG ] && $ECHO "sourceedgtestconffile(): $EDG_INSTALL_SITE_CONF file sourced"
             return 0
       fi
 else
       ### No
       . $EDG_INSTALL_SITE_CONF
       [ $DEBUG ] && $ECHO "sourceedgtestconffile(): $EDG_INSTALL_SITE_CONF file sourced"
       return 0
 fi
}