#!/usr/bin/env bash
 ### Exit code initialization
 export RET_OK=0
 export RET_PASSED=0
 export RET_ERROR=1
 export RET_WARNING=2
 export RET_XFAIL=3
 export RET_UNRESOLVED=4
 export RET_UNTESTED=5
 export RET_UNSUPPORTED=6
 export RET_DEFVAL=7
 export RETVALUE=$RET_DEFVAL

trace_status() 
# trace the returned status or the status passed as argument 
# in the log file
# in the compound final status RETVALUE   
{
 ret=$?
 if [ ! -z "$1" ]; then
   ret=$1 
 fi
 case "$ret" in
 "$RET_PASSED" | "$RET_OK" ) 
	 echo_success 
#        echo_passed could be used as well
	 ;;
 "$RET_FAIL" )
	 echo_failure 
	 ;;
 "$RET_WARNING" )	 
	 echo_warning 
 	 ;;	 
 "$RET_UNTESTED" )
         echo_untested 
	 ;;
 "$RET_XFAIL" )
         echo_xfail 
	 ;;
       * )
         echo_unresolved  
	 ret=4
	 ;;
 esac

 if [ $ret -lt $RETVALUE ] && [ $ret -ne $RET_PASSED ]; then RETVALUE=$ret ;fi 
}


#################### return_status() ##########################
return_status()
# return the final status which has been traced along the test step
{
    if [ $RETVALUE = $RET_DEFVAL ]; then RETVALUE=$RET_OK; fi
    local RETURN_STATUS=$RETVALUE
    RETVALUE=$RET_DEFVAL
    return $RETURN_STATUS
}
