#! /usr/bin/env bash
###############################################################
###############################################################
##
##                    VIEW REPORT
##    
###############################################################
###############################################################
##
## Author: Metery Rene - CS-SI (FRANCE)
##         rene.metery@c-s.fr
## Date: September 19th 2002
## Last modification : November 19th 2002
## Version: 1.0
## Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
##     http://www.edg.org/license.html or see LICENSE file
##
###############################################################
###############################################################
##
## FUNCTION: viewreport <conffilename>
## ARGUMENTS: <conffilename> {string} (mandatory)
##
## DESCRIPTION: view a test report if there is a default web browser
##              
## EXIT CODE: 0 - can view the report
##            1 - cannot view the report
##            
###############################################################
###############################################################

viewreport()
{
 if ! test $EDG_TEST_WEBBROWSER = "none"
 then
      . $1
      dir=$($ECHO $HTML_DIR | $CUT -d= -f2)
      file=$($ECHO $HTML_OUT | $CUT -d= -f2)
      $EDG_TEST_WEBBROWSER $dir/$file &
      return 0
 else
      return 1
 fi 
}
