#!/bin/bash
# 
# 05 Aout 2002
# Author:       Fede Eric fede@cppm.in2p3.fr
#
#
########################################
# Send a string on the log file and on the screen on function of the verbose level
#
# Input $1 the string
#	$2 the verbose level (0 no screen output, 1 and upper screen output)
#	$3 the path to write the logfile
#	
# RETURN VALUE: 0 PASSED
#	 	1 FAIL
#		2 WARNING
#		3 XFAIL
#		4 UNRESOLVED
#		5 UNTESTED
#		6 UNSUPPORTED
#               7 ENVIRONMENT / OPTIONS FAIL
#	
########################################

# The function

function writeOutput()
{
   local logf=$EDG_LOGFILE
   local lev=$LEVEL
   local mtyp
   
   if [ -z "$1" ]
   then
      $ECHO "writeOutput(): no mandatory parameter is passed"
      $ECHO "ALERT no parameter is passed on writeOutput">>$3
      $ECHO "">>$3
      return 1
   fi   
   if [ ! -z "$2" ]
   then
      mtyp=$2
      res=`echo $mtyp | egrep -v '[[:alpha:]]'`
      if [ $? != 0 ]
      then
      	$ECHO "writeOutput(): argument 2 is not numeric"
      	return 1
      fi
   fi



   # Write on screen and on logfile
   if [ ! -z $2 ]
   then
      lev=$2
   fi
   if [ $lev -ge 1 ]
   then
      $ECHO $1
   fi
   # Write on logfile if argument $3 is defined
   if [ ! -z $3 ]
   then
      logf=$3
   fi
   $ECHO $1 >> $logf
   return 0
}	
