#!/bin/bash
# 
# 05 Aout 2002
# Author:       Fede Eric fede@cppm.in2p3.fr
# modify 02 october 2002 by Fede Eric
########################################################################
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
#######################################################################
# Control of the time validity of the crl
# 
# RETURN VALUE: 0 PASSED
#	 	1 FAIL
#		2 WARNING
#		3 XFAIL
#		4 UNRESOLVED
#		5 UNTESTED
#		6 UNSUPPORTED
#               7 ENVIRONMENT / OPTIONS FAIL
#	
########################################
# 
#
# INPUT $1 Complet path to crl
#	$2 Path to the openssl binarie
#	
########################################
#

function verifyCRLTimeValidity_func()
{

if [ ! $1 ]; then
	writeOutput "ALERT verifyCRLTimeValidity-func function call without parameter" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH
	return 4;
fi

if [ ! $2 ]; then
	writeOutput "ALERT verifyCRLTimeValidity-func function call with the wrong number of parameter" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH
	return 4;
fi


nbcrl=0;			
for i in `ls $1/*.r0 2>/dev/null`; do
nbcrl=$[nbcrl+1];
done

if  [ $nbcrl -eq 0 ]; then 
	writeOutput "ALERT No CRL file find on $1" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;	
	return 4;
fi

writeOutput "Test the CRL validity time" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;


# testing existense of file

#	writeOutput "Your system is $datesys" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
	tlocal=`$DATE +%s`;

for i in `ls $1/*.r0 2>/dev/null`; do

	$2 crl -in $i -nextupdate -noout > t1 ;
	$CUT -f2 -d= t1 >t11;
	ii=`$CAT t11`;
	t12=`$DATE -d "$ii" +%s`;
	$RM -rf t1;
	$RM -rf t11;
	
	if [ $t12 -gt $tlocal ] ; then
		writeOutput  "Your CRL $i is valid on time" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
	else
		writeOutput "ALERT Your CRL $i is not valid (out of time)" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
		return 1;
	fi
done
 	 
return 0

}
