#!/bin/bash
# 
# 05 Aout 2002
# Author:       Fede Eric fede@cppm.in2p3.fr
#
########################################################################
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
#######################################################################
#Control if the nb of crl = ca
# 
# 
# RETURN VALUE: 0 PASSED
#	 	1 FAIL
#		2 WARNING
#		3 XFAIL
#		4 UNRESOLVED
#		5 UNTESTED
#		6 UNSUPPORTED
#               7 ENVIRONMENT / OPTIONS FAIL
#	
########################################
#
#
# INPUT $1 complet path to CRL and CA directory (1 for the both)
# 	
#
########################################


function verifyNbCAeqNbCRL_func()
{

if [ ! $1 ]; then
	writeOutput "ALERT verifyNbCAeqNbCRL-func function call without parameter" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
 
	return 4;
fi

	
nbcrl=0;			
for i in `ls $1/*.r0 2>/dev/null`; do
nbcrl=$[nbcrl+1];
done

if  [ $nbcrl -eq 0 ]; then 
	writeOutput "ALERT No CRL file find on $1" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;	
	return 4;
fi			

nbca=0;
for i in `ls $1/*.0 2>/dev/null`; do
	nbca=$[nbca+1];
done

if  [ $nbca -eq 0 ]; then 
	writeOutput "ALERT No Authority of certification file find on $1" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;	
	return 4;
fi			

writeOutput "Find $nbcrl revocation list for $nbca Authority of certification present" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;

if [ $nbcrl -eq 0 ]; then
	writeOutput "ALERT Find 0 CRL " $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
	return 4;
fi

if [ $nbcrl -lt $nbca ]; then
	writeOutput "ALERT Some autority of certification present on this host havent the corresponding list of revocation" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
	return 2;
fi

if [ $nbcrl -gt $nbca ]; then
	writeOutput "ALERT Some CRL present on this host havent the corresponding CA" $VERBOSE_LEVEL $EDG_TSTG_LOGS_PATH;
	return 2;
fi
return 0;
}
