#!/bin/bash
######################################################################
#
# Authors: Antonio Forte	- antonio.forte@to.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

. $EDG_TESTROOT/sbin/sourcer.sh

$ECHO -e "\n###############################"
$ECHO    "#### MANDATORY FILES CHECK ####"
$ECHO -e "###############################\n"

$ECHO -n "fileexist /etc/globus.conf ..."
fileexist /etc/globus.conf
print_status

$ECHO -n "getting GRIDMAP from /etc/globus.conf and check file"
checkglobusconfparam GRIDMAP
print_status

$ECHO -n "getting X509_GATEKEEPER_CERT from /etc/globus.conf and check file"
checkglobusconfparam X509_GATEKEEPER_CERT
print_status

$ECHO -n "getting X509_GATEKEEPER_KEY from /etc/globus.conf and check file"
checkglobusconfparam X509_GATEKEEPER_KEY
print_status

$ECHO -n "fileexist /etc/edg/info-mds.conf "
fileexist /etc/edg/info-mds.conf 
print_status

$ECHO -n "getting EDG_LOCATION "
if [ -z $EDG_LOCATION ]; then echo_failure; else echo_success; fi

$ECHO -n "fileexist $EDG_LOCATION/info/mds/etc/testbed1-site-globus.ldif"
fileexist $EDG_LOCATION/info/mds/etc/testbed1-site-globus.ldif       
print_status

$ECHO -n "fileexist $EDG_LOCATION/info/mds/etc/ldif/se.ldif"
fileexist $EDG_LOCATION/info/mds/etc/ldif/se.ldif
print_status

$ECHO -n "fileexist $EDG_LOCATION/etc/gdmp.conf "
fileexist $EDG_LOCATION/etc/gdmp.conf 
print_status

$ECHO -e "\n################################################"
$ECHO -e "########## CHECK MANDATORY USERS      #########"
$ECHO -e "################################################\n"

$ECHO -n "checkuser edginfo" 
checkuser edginfo
print_status

$ECHO -n "checkuser gdmp"
checkuser gdmp
print_status

$ECHO -e "\n##########################"
$ECHO    "#### RUNNING SERVICES ####"
$ECHO -e "##########################\n"

$ECHO -n "checkservice globus-gsi_wuftpd"
checkservice globus-gsi_wuftpd 
print_status

$ECHO -n "checkservice globus-gatekeeper"
checkservice globus-gatekeeper
print_status

$ECHO -n "checkservice globus-mds"
checkservice globus-mds
print_status

$ECHO -n "checkservice nfs"
checkservice nfs 
print_status

$ECHO -n "checkservice nfslock"
checkservice nfslock 
print_status

$ECHO -n "checkservice gdmp"
checkservice gdmp
print_status

$ECHO -n "checkservice ntp"
checkservice ntp
print_status

$ECHO -n "checkservice edg-gridmapfile-upgrade"
checkservice-ps edg-gridmapfile-upgrade 
print_status

$ECHO -n "checkservice edg-crl-upgrade"
checkservice-ps edg-crl-upgrade
print_status

$ECHO -e "\n##################################################"
$ECHO    "#### MANDATORY PARAMETERS IN /etc/globus.conf ####"
$ECHO -e "##################################################\n"

$ECHO -n "getting GLOBUS_LOCATION from /etc/globus.conf and check directory"
checkglobusconfparam GLOBUS_LOCATION
print_status

$ECHO -n "getting GLOBUS_GATEKEEPER_SUBJECT from /etc/globus.conf "
globus_gatekeeper_subject=`getglobusconfparam GLOBUS_GATEKEEPER_SUBJECT`
print_status

$ECHO -n "getting GLOBUS_HOST_DN from /etc/globus.conf "
globus_host_dn=`getglobusconfparam GLOBUS_HOST_DN`
print_status

$ECHO -n "getting GLOBUS_ORG_DN from /etc/globus.conf "
globus_org_dn=`getglobusconfparam GLOBUS_ORG_DN`
print_status

$ECHO -n "getting GLOBUS_GATEKEEPER_HOST from /etc/globus.conf "
globus_gatekeeper_host=`getglobusconfparam GLOBUS_GATEKEEPER_HOST`
print_status

$ECHO -n "getting GATEKEEPER_PORT from /etc/globus.conf "
gatekeeper_port=`getglobusconfparam GATEKEEPER_PORT`
print_status

$ECHO -n "getting GATEKEEPER_LOG from /etc/globus.conf and check file"
checkglobusconfparam GATEKEEPER_LOG
print_status

$ECHO -n "getting X509_CERT_DIR from /etc/globus.conf and check directory"
checkglobusconfparam X509_CERT_DIR
print_status

$ECHO -n "getting GLOBUS_JOBMANAGERS from /etc/globus.conf "
globus_jobmanagers=`getglobusconfparam GLOBUS_JOBMANAGERS`
print_status

$ECHO -n "getting GSIWUFTPPORT from /etc/globus.conf "
gsiwuftpport=`getglobusconfparam GSIWUFTPPORT`
print_status

$ECHO -n "getting GSIWUFTPDLOG from /etc/globus.conf and check file"
checkglobusconfparam GSIWUFTPDLOG
print_status

$ECHO -n "getting GRID_INFO_EDG from /etc/globus.conf "
grid_info_edg=`getglobusconfparam GRID_INFO_EDG`
print_status

$ECHO -n "getting GLOBUS_FLAVOR_NAME from /etc/globus.conf "
globus_flavor_name=`getglobusconfparam GLOBUS_FLAVOR_NAME`
print_status

$ECHO -n "getting GRID_INFO_GRIS_REG_GIIS from /etc/globus.conf "
grid_info_gris_reg_giis=`getglobusconfparam GRID_INFO_GRIS_REG_GIIS`
print_status

$ECHO -n "getting GRID_INFO_GRIS_REG_HOST from /etc/globus.conf "
grid_info_gris_reg_host=`getglobusconfparam GRID_INFO_GRIS_REG_HOST`
print_status


$ECHO -e "\n########################################################"
$ECHO    "#### MANDATORY PARAMETERS IN /etc/edg/info-mds.conf ####"
$ECHO -e "########################################################\n"

$ECHO -n "getting WP3_DEPLOY from /etc/edg/info-mds.conf"
wp3_deploy=`getfileparam WP3_DEPLOY /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting FTREE_INFO_PORT from /etc/edg/info-mds.conf"
ftree_info_port=`getfileparam FTREE_INFO_PORT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting FTREE_DEBUG_LEVEL from /etc/edg/info-mds.conf"
ftree_debug_level=`getfileparam FTREE_DEBUG_LEVEL /etc/edg/info-mds.conf 0`
print_status

$ECHO -n "getting SITE_DN from /etc/edg/info-mds.conf"
site_dn=`getfileparam SITE_DN /etc/edg/info-mds.conf Mds-Vo-Name=local,o=Grid`
print_status

$ECHO -n "getting NETMON_PRESENT from /etc/edg/info-mds.conf"
netmon_present=`getfileparam NETMON_PRESENT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting NETMON_PINGER_HOST from /etc/edg/info-mds.conf"
netmon_pinger_host=`getfileparam NETMON_PINGER_HOST /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SE_PRESENT from /etc/edg/info-mds.conf"
se_present=`getfileparam SE_PRESENT /etc/edg/info-mds.conf yes`
print_status

$ECHO -n "getting SE_ID from /etc/edg/info-mds.conf"
se_id=`getfileparam SE_ID /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SE_SIZE from /etc/edg/info-mds.conf"
se_size=`getfileparam SE_SIZE /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SE_CONTACT from /etc/edg/info-mds.conf"
se_contact=`getfileparam SE_CONTACT /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SE_TYPE from /etc/edg/info-mds.conf"
se_type=`getfileparam SE_TYPE /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SE_FILESYSTEMS from /etc/edg/info-mds.conf"
se_filesystems=`getfileparam SE_FILESYSTEMS /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SE_CLOSE_CE from /etc/edg/info-mds.conf"
se_close_ce=`getfileparam SE_CLOSE_CE /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SE_PROTOCOLS from /etc/edg/info-mds.conf"
se_protocols=`getfileparam SE_PROTOCOLS /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SE_PROTOCOL_PORTS from /etc/edg/info-mds.conf"
se_protocol_port=`getfileparam SE_PROTOCOL_PORTS /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SE_VO from /etc/edg/info-mds.conf"
se_vo=`getfileparam SE_VO /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting SITE_NETMON_HOSTS from /etc/edg/info-mds.conf"
site_netmon_hosts=`getfileparam SITE_NETMON_HOSTS /etc/edg/info-mds.conf`
print_status

$ECHO -n "getting GRID_INFO_USER from /etc/edg/info-mds.conf"
grid_info_user=`getfileparam GRID_INFO_USER /etc/edg/info-mds.conf edginfo`
print_status

$ECHO -e "\n###############################################################################"
$ECHO    "#### Node Information (from $EDG_LOCATION/info/mds/etc/ldif/se.ldif ####"
$ECHO -e "###############################################################################\n"

$CAT $EDG_LOCATION/info/mds/etc/ldif/se.ldif


$ECHO -e "\n##############################"
$ECHO    "#### RPM check procedure ####"
$ECHO -e "#############################\n"

$ECHO "verify RPM list installation"
rpmchecker $EDG_TESTROOT/sbin/SE-v1_2_0.rpmlist
print_status

$ECHO -e "\n###############################"
$ECHO    "####   MDS / GRIS CHECK    ####"
$ECHO -e "###############################\n"

$ECHO -n "seinfoprovcheck "
seinfoprovcheck
print_status

$ECHO -e "\n###############################"
$ECHO    "####   MDS / GRIS QUERY    ####"
$ECHO -e "###############################\n"

$ECHO -n "grisqueryse "
grisqueryse
print_status
