#!/bin/bash
# 
# 31/01/03
# Author:       Frederique Chollet chollet@lapp.in2p3.fr
# 
########################################################################
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
#######################################################################
# Verify SE Mds Configuration -
# Compliant with EDG v1.4.x Installation Guide
# Document identifier : DataGrid-01-TED-0105-1-25
# 
# RETURN VALUE: 0 PASSED
#	 	1 FAIL
#		2 WARNING
#		3 XFAIL
#		4 UNRESOLVED
#		5 UNTESTED
#		6 UNSUPPORTED
#               7 ENVIRONMENT / OPTIONS FAIL
#	
########################################
# 
#
# INPUT none
#	
#	
########################################
#

function verifySEMdsConf()
{
    	$ECHO -n "WP3_DELOY in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        wp3_deploy=`getfileparam WP3_DEPLOY $EDG_TEST_INFOMDSCF` && [ -d $w3_deploy ]
	trace_status
	$ECHO -n "FTREE_INFO_PORT in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
 	ftree_info_port=`getfileparam FTREE_INFO_PORT $EDG_TEST_INFOMDSCF` && test $ftree_info_port = 2171
 	trace_status
	$ECHO -n "FTREE_DEBUG_LEVEL in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
	ftree_debug_level=`getfileparam FTREE_DEBUG_LEVEL $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SITE_DN in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        site_dn=`getfileparam SITE_DN $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "GRID_INFO_USER in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
    	grid_info_user=`getfileparam GRID_INFO_USER $EDG_TEST_INFOMDSCF` && checkuser $grid_info_user 
	trace_status
	$ECHO -n "SITE_INFO in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        site_info=`getfileparam SITE_INFO $EDG_TEST_INFOMDSCF` && test "$site_info" = "yes"
        trace_status
	$ECHO -n "SITE_NAME in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
	site_name=`getfileparam SITE_NAME $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SITE_CPU_RESOURCE_DESCRIPTION in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        site_cpu_resource_description=`getfileparam SITE_DISK_RESOURCE_DESCRIPTION $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SITE_DISK_RESOURCE_DESCRIPTION in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        site_disk_resource_description=`getfileparam SITE_DISK_RESOURCE_DESCRIPTION $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SITE_INSTALLATION_DATE in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
       	site_installation_date=`getfileparam SITE_INSTALLATION_DATE $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SITE_SYSADMIN_CONTACT in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
       	site_sysadmin_contact=`getfileparam SITE_SYSADMIN_CONTACT $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SITE_USER_SUPPORT_CONTACT in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
       	site_user_support_contact=`getfileparam SITE_USER_SUPPORT_CONTACT $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SITE_SECURITY_CONTACT in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
       	site_security_contact=`getfileparam SITE_SECURITY_CONTACT $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SITE_DATAGRID_VERSION in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
       	site_datagrid_version=`getfileparam SITE_DATAGRID_VERSION $EDG_TEST_INFOMDSCF` && test "$site_datagrid_version" = "v$EDG_VERSION"
	trace_status
	$ECHO -n "SITE_SE_HOSTS in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        site_se_hosts=`getfileparam SITE_SE_HOSTS $EDG_TEST_INFOMDSCF` && test "$site_se_hosts" = "$SITE_SE_HOSTS_"
	trace_status
	$ECHO -n "SITE_CE_HOSTS in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        site_ce_hosts=`getfileparam SITE_CE_HOSTS $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "NETMON_PRESENT in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
       	netmon_present=`getfileparam NETMON_PRESENT $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "NETMON_PINGER_HOST in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        netmon_pinger_host=`getfileparam NETMON_PINGER_HOST $EDG_TEST_INFOMDSCF` && test "$netmon_pinger_host" = `hostname`
	trace_status
	$ECHO -n "SE_PRESENT in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        se_present=`getfileparam SE_PRESENT $EDG_TEST_INFOMDSCF` && test "$se_present" = "yes"
	trace_status
	$ECHO -n "SE_ID in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        se_id=`getfileparam SE_ID $EDG_TEST_INFOMDSCF` && test "$se_id" = `hostname`
	trace_status
	$ECHO -n "SE_SIZE in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        se_size=`getfileparam SE_SIZE $EDG_TEST_INFOMDSCF` 
	trace_status
	$ECHO -n "SE_TYPE in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        se_type=`getfileparam SE_TYPE $EDG_TEST_INFOMDSCF` 
	trace_status
	$ECHO -n "SE_FILESYSTEMS in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
        se_files_system=`getfileparam SE_FILESYSTEMS $EDG_TEST_INFOMDSCF` && fileexist $se_files_system
	trace_status
#
	$ECHO -n "SE_PROTOCOL_PORTS in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
	se_protocols=`getfileparam SE_PROTOCOLS $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SE_PROTOCOL_PORTS in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
	se_protocols_ports=`getfileparam SE_PROTOCOL_PORTS $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SE_CLOSE_CE in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
	ce_queue=`getfileparam SE_CLOSE_CE $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SE_VO in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
	site_netmon_host=`getfileparam SE_VO $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SITE_NETMON_HOST in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
	site_netmon_host=`getfileparam SITE_NETMON_HOST $EDG_TEST_INFOMDSCF`
	trace_status
	$ECHO -n "SITE_NETMON_HOSTS in "$EDG_TEST_INFOMDSCF >>$TMP_LOG_FILE 2>&1
	site_netmon_hosts=`getfileparam SITE_NETMON_HOSTS $EDG_TEST_INFOMDSCF`
	trace_status
# 
	$ECHO -n "SE GRIS Infos published" >>$TMP_LOG_FILE 2>&1
	ldapsearch -x -H ldap://`hostname`:2135 -b $site_dn | $GREP SEId 
#	ldapsearch -LLL -x -H ldap://`hostname`:2135 -b $site_dn "(objectClass=ComputingElement)" CEId TotalCPUs LRMSType QueueName Active FreeCPUs 
	trace_status
 
	return 

}
