#!/bin/bash
#$Id: WorkerNode-test.sh,v 1.1.1.2 2005/02/08 16:09:44 mbarroso Exp $
######################################################################
#
# Authors: Gennaro Tortone	- Gennaro.Tortone@na.infn.it
#
# Copyright 2001-2002 EU DataGrid project (2002), WP6 TestBed
#                    http://www.edg.org/license.html
#
######################################################################

. $EDG_TESTROOT/sbin/sourcer.sh

$ECHO -e "\n##########################"
$ECHO    "#### RUNNING SERVICES ####"
$ECHO -e "##########################\n"

$ECHO -n "checkservice edg-crl-upgraded"
checkservice edg-crl-upgraded
print_status

$ECHO -n "checkservice globus-gsi_wuftpd"
checkservice globus-gsi_wuftpd
print_status

$ECHO -n "checkservice globus-mds"
checkservice globus-mds
print_status

$ECHO -n "checkservice inet"
checkservice inet
print_status

$ECHO -n "checkservice nfslock"
checkservice nfslock 
print_status

$ECHO -n "status pbs_mom"
status pbs_mom
print_status

$ECHO -n "checkservice ntp"
checkservice ntp 
print_status

$ECHO -e "\n################################"
$ECHO    "#### USER ENVIRONMENT CHECK ####"
$ECHO -e "##################################\n"

$ECHO -n "fileexist /etc/profile.d/globus.sh"
fileexist /etc/profile.d/globus.sh
print_status

$USERADD tstacct

userpath=`su - tstacct -c "$ECHO \$PATH"`
userldlib=`su - tstacct -c "$ECHO \$LD_LIBRARY_PATH"`

$ECHO -n "checking /opt/globus/bin in \$PATH"
checkpathvar $userpath /opt/globus/bin
print_status

$ECHO -n "checking /opt/globus/sbin in \$PATH"
checkpathvar $userpath /opt/globus/sbin
print_status

$ECHO -n "checking /opt/edg/bin in \$PATH"
checkpathvar $userpath /opt/edg/bin
print_status

$ECHO -n "checking /opt/globus/lib in \$LD_LIBRARY_PATH"
checkpathvar $userldlib /opt/globus/lib
print_status

$ECHO -n "checking /opt/edg/lib in \$LD_LIBRARY_PATH"
checkpathvar $userldlib /opt/edg/lib
print_status

$USERDEL -r tstacct

$ECHO -e "\n##################################"
$ECHO    "#### NFSmount check procedure ####"
$ECHO -e "##################################\n"

$ECHO -n "check nfsmount for WN"
check_nfs_mount=`checknfsmount WN`
print_status

$ECHO -e "\n#############################"
$ECHO    "#### RPM check procedure ####"
$ECHO -e "#############################\n"

$ECHO "verify RPM list installation"
rpmchecker $EDG_TESTROOT/sbin/WN-v1_2_2.rpmlist
print_status

$ECHO -e "\n######################"
$ECHO    "####   PBS CHECK   ####"
$ECHO -e "#######################\n"

$ECHO "verify /usr/spool/PBS/pbs_environment "
checkPBSenv
print_status

$ECHO "verify /usr/spool/PBS/server_name with layout.sh info "
checkPBSservername
print_status

#
